# GitBlogs（基于 GitHub 的个人博客）

![](emoji.jpg)

> 读书，不是非做不可的事。而是想要去做的事。    
> 今后你们可能会碰到很多很多你们不知道的事。            
> 也会碰到很多你们觉得美好的、开心的、不可思议的事物。       
> 这时候作为一个人，自然想了解更多，学习更多。        
> 失去好奇心和求知欲的人，不能称为人，连猴子都不如。            
> 连自己生存的这个世界都不想理解。还能做什么呢？         
> 不论如何学习，只要人活着，就有很多不懂的东西。  
> 这个世界上有很多大人好像什么都懂的样子，那都是骗人的。      
> 进了大学也好，进了好公司也好，      
> 如果有活到老学到老的想法，那就有无限的可能性。        
> 失去好奇心的那一瞬间，人就死了。      
> 读书不是为了考试，而是为了成为出色的大人。
> 
> —— 日剧 《女王的教室》

## 模块导航
### 0.1 [OJ 大杂烩](https://github.com/gdut-yy/GitBlogs/tree/master/module-oj/README.md)
### 0.2 [校选教材](https://github.com/gdut-yy/GitBlogs/tree/master/module-edus/README.md)
### 0.3 技术类书籍
### 0.4 泛技术类书籍
### 0.5 电影 & 电视剧


## 〇、目录
| 序号 | 分类 | 内容 |
| :-: | :-: | - |
| 1 | 计算机基础-base（1.1 ~ 1.4） | 数据结构、算法、计算机网络、操作系统、数据库 |
| 2 | 编程语言-language | Java、JavaScript、C/C++、Python、Kotlin、Dart、Go、Erlang |
| 3 | 通用-common（1.5 ~ 1.6） | 设计模式、重构 |
| 4 | 服务端开发-backend（1.7 ~ 1.11） | 框架、架构、中间件 |
| 5 | 运维-sre（1.12） | Linux、ELK、Dokcer、k8s |
| 6 | 移动端开发-mobile（1.13） | Android、Flutter |
| 7 | 前端开发-fontend（1.14） | Node.js |
| 8 | 算法/AI | 机器学习、深度学习 |
| 9 | 泛技术（1.16） | 泛技术 |

## 一、技术栈分类

### 1.1 数据结构 & 算法
1. [《数据结构（C语言版）》 严蔚敏 吴伟民 编著](module-techs/SHUJUJIEGOU_YAN)
2. [《大话数据结构》 程杰 著](module-techs/DAHUASHUJUJIEGOU)
3. [《数据结构与算法分析——C语言描述（原书第2版）》（*Data Structures and Algorithm Analysis in C, Second Edition*）](module-techs/DataStructuresinC2)
4. [《算法：C语言实现（第1~4部分）基础知识、数据结构、排序及搜索（原书第3版）》（*Algorithms in C: Parts 1-4 Fundamentals, Data Structures, Sorting, Searching, Third Edition*）](module-techs/AlgorithmsinC1-4)
5. 《算法：C语言实现（第5部分）图算法》
6. [《算法导论（原书第3版）》（*Introduction to Algorithms(Third Edition)*）](module-techs/ItoAlgorithms3)
7. [《算法（第4版）》（*Algorithms(Fourth Edition)*）](module-techs/Algorithms4)


### 1.2 计算机网络
1. [《TCP/IP 详解 卷1：协议（原书第2版）》（*TCP/IP Illustrated, Volume 1: The Protocols, Second Edition*）](module-techs/TCPIP_1)
2. [《TCP/IP 详解 卷2：实现》（*TCP/IP Illustrated, Volume 2: The Implementation*）](module-techs/TCPIP_2)
3. [《TCP/IP 详解 卷3：TCP事务协议、HTTP、NNTP和UNIX域协议》（*TCP/IP Illustrated, Volume 3: TCP for Transactions,HTTP,NNTP,and the UNIX Domain Protocols*）](module-techs/TCPIP_3)
4. [《计算机网络（第5版）》（*Computer Networks, Fifth Edittion*）](module-techs/ComputerNetworks5)


### 1.3 操作系统
1. [《深入理解计算机系统（原书第3版）》（*Computer Systems: A Programmer's Perspective, Third Edition*）](module-techs/ComputerSystems3)


### 1.4 数据库
1. [《数据库系统概念（原书第6版）》（Database System Concepts, Sixth Edition）](module-techs/DatabaseSystem6)
2. [《数据库系统实现》（*Database System Implementation,Second Edition*）](module-techs-extra/SHUJUKUXITONGSHIXIAN)
3. [《高性能 MySQL（第三版）》（*High Performance MySQL*）](module-techs/High-Performance-MySQL)
4. [《PostgreSQL 实战》 谭峰 张文升 编著](module-techs-extra/PostgreSHIZHAN)
5. 《MySQL 8 Cookbook（中文版）》


### 1.5 设计模式
1. [《大话设计模式》 程杰 著](module-techs/DAHUASHEJIMOSHI)
2. [《设计模式：可复用面向对象软件的基础》（*GoF*）](module-techs/GoF)
3. [《设计模式之禅（第2版）》 秦小波 著](module-techs/SHEJIMOSHIZHICHAN)
4. [《Head First 设计模式》](module-techs-extra/HeadFirst-SHEJIMOSHI)


### 1.6 重构
1. [《重构：改善既有代码的设计》（*Refactoring : Improving the Design of Existing Code*）](module-techs/Refactoring)
2. [《代码整洁之道》（*Clean Code : A Handbook of Agile Software Craftsmanship*）](module-techs/CleanCode)
3. [《架构整洁之道》（*Clean Architecture*）](module-techs/CleanArchitecture)


### 1.7 Java & JVM
1. [《Java 核心技术 卷I》（原书第十版）（*Core Java Volume I——Fundamentals (10th Edition)*）](module-techs/CJV-I10)
2. [《Java 核心技术 卷II》（原书第十版）（*Core Java Volume II——Advance Features (10th Edition)*）](module-techs/CJV-II10)
3. [*Effecitive Java (Third Edition)*](module-techs/EJ3)
4. [《Java 编程思想（第4版）》（*Thinking in Java (Fourth Edition)*）](module-techs/TIJ4)
5. [《Java 并发编程实战》（*Java Concurrency in Practice*）](module-techs/JCP)
6. [《深入理解 Java 虚拟机（第2版）》 周志明 著](module-techs/JVM)
7. [《Java 8 函数式编程》（*Java 8 Lambdas : Functional Programming For The Masses*）](module-techs/Java8Lambdas)
8. [《Java 9 模块化开发：核心原则与实践》（*Java 9 Modularity : Patterns and Practices for Developing Maintainable Applications*）](module-techs/Java9Modularity)
9. [《Java 多线程编程核心技术》 高洪岩 著](module-techs/JavaDUOXIANCHENG)
10. [《Java 性能权威指南》（*Java Performance : The Definitive Guide*）](module-techs/Java-Performance)
11. 《JRockit 权威指南：深入理解 JVM》（*Oracle JRockit : The Definitive Guide*）


### 1.8 框架
1. [《Spring 实战（第4版）》（*Spring In Action, Fourth Edition*）](module-techs/Spring)
2. [《Spring Boot 实战》（*Spring Boot In Action*）](module-techs/SpringBoot)
3. [《Spring 微服务实战》（*Spring Microservices In Action*）](module-techs/SpringMicro)
4. 《Netty 实战》（*Netty In Action*）
5. [《RxJava2.x 实战》 沈哲 编著](module-techs/RxJava2)
6. 《云原生 Java》（*Cloud Native Java*）
7. [《Spring 源码深度解析（第 2 版）》 郝佳 编著](module-techs/SpringYUANMASHENDUJIEXI)
8. 《Struts2 实战》（*Struts2 in action*）
9. *OAuth2 In Action*
10. 《REST 实战》（*REST in Practice*）
11. 《Netty 进阶之路：跟着案例学 Netty》 李林锋 著


### 1.9 架构
1. [《大型网站 技术架构演进与性能优化》 许令波（君山） 著](module-techs/DAXINGWANGZHANJISHUJIAGOU)
2. [《分布式服务框架原理与实践》 李林锋 著](module-techs/FENBUSHIFUWUKUANGJIA)


### 1.10 中间件（Redis、MQ）
1. [《Redis 4.x Cookbook 中文版》 黄鹏程 王左非 著](module-techs/Redis-Cookbook)
2. [《分布式消息中间件实践》 倪炜 著](module-techs/MQ-Middleware)
3. [《RocketMQ 实战与原理解析》 杨开元 著](module-techs/RocketMQ-SHIZHANYUYUANLIJIEXI)
4. [《RocketMQ 技术内幕：RocketMQ 架构设计与实现原理》 丁威 周继峰 著](module-techs/RocketMQ-JIAGOUSHEJIYUSHIXIANYUANLI)
5. 《深入理解 Kafka：核心设计与实践原理》 朱忠华 著
6. 《RabbitMQ 实战：高效部署分布式消息队列》 （*RabbitMQ in Action : Distributed Messageing for Everyone*）
7. [《ZooKeeper 分布式过程协同技术详解》（*ZooKeeper : Distributed Process Coordination*）](module-techs/ZooKeeper-DistributedProcessCoordination)
8. [《从 Paxos 到 ZooKeeper：分布式一致性原理与实践》 倪超 著](module-techs/PaxosTOZooKeeper)


### 1.11 运维（Linux、ELK、Dokcer、k8s）
1. [《鸟哥的Linux私房菜——基础学习篇（第三版）》 鸟哥 著](module-techs/NIAOGE-I)
2. [《鸟哥的Linux私房菜——服务器架设篇（第三版）》 鸟哥 著](module-techs/NIAOGE-II)
4. [《Elasticsearch 实战》（*Elasticsearch In Action*）](module-techs/Elasticsearch-In-Action)
5. [《Docker 实践》（*Docker IN PRACTICE*）](module-techs/Docker-IN-PRACTICE)
6. 《Kubernetes 权威指南：从 Docker 到 Kubernetes 实践全接触》（*Kubernetes : The Definitive Guide*）
7. 《Docker 开发指南》（*Using Docker*）
8. 《Docker 经典实例》（*Docker Cookbook*）
9. 《Docker 即学即用》（*Docker : Using and Running*）
10. 《第一本 Docker 书》（*THE DOCKER BOOK*）
11. 《Jenkins 权威指南》（*Jenkins : The Definitive Guide*）
12. 《Linux 命令行与 shell 脚本编程大全（第 3 版）》（*Linux Command Line and Shell Scripting Bible, 3E*）


### 1.12 移动端
1. [《第一行代码——Android（第2版）》 郭霖 著](module-techs/Android-DIYIHANGDAIMA2)
2. [《Android 编程权威指南（第三版）》（*Android Programming The Big Nerd Ranch Guide, Third Edition*）](module-techs/Android-Programming3)
3. [《Android 开发艺术探索》 任玉刚 著](module-techs/Android-KAIFAYISHUTANSUO)
4. 《Android 群英传》 徐宜生 著
5. 《Android 群英传：神兵利器》 徐宜生 著
6. 《Android 源码设计模式：解析与实战》 何红辉 关爱民 著
7. 《App 研发录：架构设计、Crash分析和竞品技术分析》 包建强 著
8. 《Android 进阶之光》 刘望舒 著
9. [《Android 进阶解密》 刘望舒 著](module-techs/Android-JINJIEJIEMI)
10. [《Android 组件化架构》 苍王 著](module-techs/Android-ZHUJIANHUA)
12. [《Kotlin 实战》（*Kotlin In Action*）](module-techs/Kotlin-in-action)
13. [《Android 音视频开发》 何俊林 著](module-techs/Android-YINSHIPINKAIFA)
14. [《Flutter 技术入门与实战》 亢少军 著](module-techs/Android-Flutter-JISHURUMENYUSHIZHAN)


### Dart 语言
1. [《Dart 语言程序设计》（*Dart for Hipsters : Fast,Flexible,Structured Code for the Moden Web*）](module-techs/DartForHipsters)
2. 《Dart 编程语言》（*The Dart Programming Language*）


### Go 语言
1. 《Go 语言实践》（*Go In Action*）
2. 《Go 程序设计语言》（*The Go Programming Language*）


### 1.13 前端相关（HTML、CSS、JavaScript）
1. [《JavaScritp 高级程序设计（第3版）》（*Professional JavaScript for Web Developers 3rd Edition*）](module-techs/PJWD3)
2. [《JavaScritp DOM 编程艺术（第2版）》（*DOM Scripting Web Design with JavaScript and the Document Object Model Second Edition*）](module-techs/DOMScripting2)
3. [《深入浅出 Node.js》 朴灵 著](module-techs/Nodejs)
4. [《CSS 权威指南（第4版）》（*CSS: The Definitive Guide, 4th Edition Visual Presentation for the Web*）](module-techs/CSSTDG4)
5. 《Node.js 实战：使用 Egg.js + Vue.js + Docker 构建渐进式、可持续集成与交付应用》 陈微明 著


### 1.14 C/C++ （C/C++ 非常重要且复杂，由于时间关系，无限期待更）
1. [《C 程序设计语言（第2版·新版）》（*K&R(Second Edition)*）](module-techs/K&R2)
2. [《C++ Primer Plus（第6版）》](module-techs/C++PP)
3. [《C Primer Plus（第五版）》](module-techs/CPP)
4. [《C++ Primer（第5版）》](module-techs/C++P)
5. [《C++ 编程思想》（*Thinking in C++*）](module-techs/TIC++)


### 1.15 机器学习、深度学习
1. [《机器学习》（*Machine Learning*）](module-techs-extra/MachineLearning)
2. [《深度学习》（*Deep Learning*）](module-techs-extra/DeepLearning)
3. [《模式识别》 张学工 著](module-techs-extra/MOSHISHIBIE)


### 1.16 泛技术书籍
1. [《编码：隐匿在计算机软硬件后的语言》（*Code : The Hidden Language of Computer Hardware and Software*）](module-techs-extra/Code)
2. [《人件（原书第3版）》（*Peopleware: Productive Projects and Teams (Third Edition)*）](module-techs-extra/Peopleware3)
3. [《浪潮之巅》](module-techs-extra/LANGCHAOZHIDIAN) | [《硅谷之谜》](module-techs-extra/GUIGUZHIMI) | 《数学之美》 | [《见识》](module-techs-extra/JIANSHI) | 《态度》 | [《大学之路》](module-techs-extra/DAXUEZHILU) | 《文明之光》 | [《智能时代：大数据与智能革命重新定义未来》](module-techs-extra/ZHINENGSHIDAI) 吴军 著
7. [《基业长青》 吉姆·柯林斯 等著](module-techs-extra/JIYECHANGQING)
8. [《物演通论》 王东岳 著](module-techs-extra/WUYANTONGLUN)
9. [《失控：全人类的最终命运和结局》](module-techs-extra/SHIKONG) | 《科技想要什么》 | [《必然》](module-techs-extra/BIRAN) 凯文·凯利 著（“KK 三部曲”）
10. 《新经济，新规则：网络经济的十种策略》 | 《技术元素》 凯文·凯利 著
10. [《进入空气稀薄地带》 乔恩·克拉考尔（Jon Krakauer）著](module-techs-extra/JINRUKONGQIXIBODIDAI)
11. [《美国简史》 亨德里克·威廉·房龙 著](module-techs-extra/MEIGUOJIANSHI)
12. [《鞋狗》 （*SHOE DOG*）](module-techs-extra/XIEGOU)
13. [《从 0 到 1》 彼得·蒂尔，布莱克·马斯特斯（Blake Masters）著](module-techs-extra/CONG0DAO1)
14. [《深度思考：不断逼近问题的本质》 莫琳.希凯 著](module-techs-extra/SHENDUSIKAO)
15. [《麦肯锡卓越工作方法》](module-techs-extra/MAIKENXIWENTIFENXIYUJIEJUEJIQIAO)
16. [《人月神话》（*The Mythical Man-Month：Essays on Software Engineering Anniversary Edition*）](module-techs-extra/RENYUESHENHUA)
17. [《程序员健康指南》 JoeKutner 著](module-techs-extra/CHENGXUYUANJIANKANGZHINAN)
18. [《赋能：打造应对不确定性的敏捷团队》（*Team of Teams*）](module-techs-extra/TeamOfTeams)
19. [《人类简史（新版）：从动物到上帝》](module-techs-extra/RENLEIJIANSHI) | [《未来简史：从智人到智神》](module-techs-extra/WEILAIJIANSHI) | [《今日简史：人类命运大议题》](module-techs-extra/JINRIJIANSHI)（“简史三部曲”）
20. [《黑客与画家》 Paul Graham 著](module-techs-extra/HEIKEYUHUAJIA)
21. [《运筹学》 罗纳德 L.拉丁 著](module-techs-extra/YUNCHOUXUE)
22. [《曾国藩》 唐浩明 著](module-techs-extra/ZENGGUOFAN)
23. [《正义之心：为什么人们总是坚持“我对你错”》（*The Righteous Mind*）](module-techs-extra/TheRighteousMind)
24. [《重新定义公司：谷歌是如何运营的》（*How Google Works*）](module-techs-extra/HowGoogleworks)
25. [《刷新：重新发现商业与未来》（*Hit Refresh*）](module-techs-extra/SHUAXIN)
26. 《编程珠玑（第2版）》（*Programming Perals, Second Edition*）
27. 《编程珠玑·续》（*More Programming Perals*）
28. [《正则指引（第2版）》 余晟 著](module-techs/ZHENGZEZHIYIN2)
29. [《禅与摩托车维修艺术》（*Zen and the Art of Motorcycle Maintenance*）](module-techs-extra/ZenAndTheArtOfMotorcycleMaintenance)
32. 《人人都是产品经理 2.0：写给泛产品经理》 苏杰 著
34. 《终身成长（全新修订版）》 卡罗尔·德韦克 著 
35. 《清单革命：如何持续、正确、安全地把事情做好》 阿图·葛文德 著
36. 《亲密关系》
37. 《非暴力沟通》
38. 《男人来自火星，女人来自金星：修炼亲密关系的方法》（*Beyond MARS and VENUS*）
39. 《白帽子讲 Web 安全》
40. [《MacTalk 人生元编程》](module-techs-extra/MACTALK-RENSHENGYUANBIANCHENG) | [《MacTalk 跨越边界》](module-techs-extra/MACTALK-KUAYUEBIANJIE) 迟建强 著
41. [《前方的路》](module-techs-extra/QIANFANGDELU) | [《未来世界的幸存者》](module-techs-extra/WEILAISHIJIEDEXINGCUNZHE) 阮一峰 著
43. 《黄金时代》 | 《白银时代》 | 《青铜时代》 | 《沉默的大多数》 | 《我的精神家园》 | 《一只特立独行的猪》 王小波 著
44. 《奇特的一生：柳比歇夫坚持56年的“时间统计法”》 格列宁 著
45. [《吃掉那只青蛙：博恩·崔西的高效时间管理法则（原书第3版）》 博恩·崔西 著](module-techs-extra/CHIDIAONAZHIQINGWA/README.md)
46. [《番茄工作法图解：简单易行的时间管理方法》 史蒂夫·诺特伯格 著](module-techs-extra/FANQIEGONGZUOFATUJIE/README.md)
47. 《高效能人士的七个习惯》 史蒂芬·柯维 著
48. 《时间管理——如何充分利用你的24小时》 吉姆·兰德尔 著
49. 《把时间留给最重要的事：高效能人士的自我管理手册》 洛塔尔·赛韦特 著
50. 《爆发：大数据时代预见未来的新思维》 艾伯特－拉斯洛·巴拉巴西 著


### 1.17 技术笔试面试
1. [《剑指 Offer：名企面试官精讲典型编程题（第2版）》 何海涛 著](module-techs/JIANZHIOffer/README.md)
2. [《编程之美——微软技术面试心得》 《编程之美》小组 著](module-techs/BIANCHENGZHIMEI/README.md)


## 1.17 阿里技术
1. [《技术之瞳——阿里巴巴技术笔试心得》 阿里巴巴集团校园招聘笔试项目组 著](module-techs/JISHUZHITONG)
2. [《码出高效 Java 开发手册》 杨冠宝（孤尽） 高海慧（鸣莎） 著](module-techs/MACHUGAOXIAO)
3. [《逆流而上：阿里巴巴技术成长之路》 阿里巴巴集团成长集编委会 著](module-techs-extra/NILIUERSHANG)
4. [《大数据之路》 阿里巴巴数据技术及产品部 著](module-techs-extra/DASHUJUZHILU)
5. 《尽在双11——阿里巴巴技术演进与超越》 阿里巴巴集团双11技术团队 著
6. [《深入探索 Android 热修复技术原理》 甘晓霖 廖斌斌 杨青 编著](module-techs/Android-REXIUFU)
7. [《企业 IT 架构转型之道阿里巴巴中台战略思想与架构实战》 钟华 著](module-techs-extra/QIYEITJIAGOUZHUANXINGZHIDAO)
8. [《淘宝技术这十年》 子柳 著](module-techs-extra/TAOBAOJISHUZHESHINIAN)
9. [《淘宝十年产品事》 苏杰 编著](module-techs-extra/TAOBAOSHINIANCHANPINSHI)


## 二、相关链接

### 2.1 [漫漫 Offer 路 (๑و•̀Δ•́)و](https://github.com/gdut-yy/GitBlogs/tree/master/offer/README.md)
### 2.2 [我的博客(ノ￣▽￣)](https://github.com/gdut-yy/GitBlogs/tree/master/module-blogs/README.md)

## 三、后记

无他。

书读多了会忘。

手写笔记不堪入目，遂用 GitHub。

—— 2018年7月26日

对比起其他写作渠道（微信公众号、CSDN、博客园、简书等）

还是感觉 GitHub 写博客最方便。

不用审核，没有字数限制，修改容易。

遂改名为 GitBlogs 。

—— 2018年11月29日
