
# 2018 年终总结
 
前言：2019 年一月里的一个平平常常的日子，冷风夹着细蒙蒙的雨丝，正纷纷淋淋地向广州大学城飘洒着。时令已过小寒，2018 年严寒而漫长的冬天眼看就要过去，但那真正温暖的春天却远远没有到来。这一年的冬天异常冷，在经济的凛冬面前，每个人仿佛都很无力。人不是鸭，冷暖不能先知，只能自知。这一年间，我和身边的同龄人开始从校园迈向社会，经历着成长的剧痛。在这岁末年初之际，有必要对这一年里所发生的事情做一下总结。虽然思考不一定会有进步，但不反思，就永远都不会有进步。本文主要思考并记录了自己这一年里的生活和工作、技术成长、反思以及对未来的规划和展望等。


关于生活。人们习惯把 2018 年称为 8102 年，用来夸张这个时间的久远，常用作吐槽过时、陈旧。2018，我从年初参加比赛开始，到春招，秋招，实习一路走来。纵观整个大学生涯，我也曾有过很多无忧无虑的时光。义教、心协、车协中的经历留给了我很多美好的回忆。转折点大概是 2017 年的岁末，那年冬天也是差不多这般冷，我从南水湖公路车比赛（骑游）回来后，便开始放下自行车，认真完成每一门课程作业、报告。从此骑车的次数便渐渐减少，话语也渐渐减少。


在这个实用主义和功利主义至上的年代，不实用就是一种奢侈。如果不能增加社交活动中的谈资，读一本诺贝尔获奖作家的小说，看一部 IMDB TOP 250 的电影就是奢侈的；如果不能拍照发朋友圈，假期外出旅游就是奢侈的。所以我们会开两倍速（甚至更高）来电影，电视剧；愿意为花少力气去看世界名著的缩写本，而不是费力地去啃原著；愿意使用各种框架工具而不深究其实现原理；因为我们认为这么干的性价比更高。


从 2008 年 11 月开始，我开始写日记。那一年我小学还没毕业。曾不止一次地想象过 10 年后的自己会是什么模样，在何处、干何事。当时最大的梦想应该是小升初能考上好的初中。那么，现在的梦想是什么呢？如同在面试时面试官会问 “你为什么会选择这个专业？” “为什么选择这个方向？” 这类问题潜台词是想得知你的选择价值观和对人生的规划。


我不禁回想起那个夏天，大概是 06-07 年的时候，家里的电脑装了宽带。那时我喜欢一玩款名叫《跑跑卡丁车》的游戏，可是老爸为了避免我沉迷游戏，给电脑设了密码，防止我偷玩。我当然是不能妥协的，为了玩游戏，我便想方设法弄到密码，依稀记得当时是利用 Win XP 系统的一个漏洞，使用一款插件拿到的明文密码。我无从考究爸妈是否知道我知道电脑的密码一事，大概就是这个期间我渐渐对电脑的运行机制产生了兴趣，期间也帮不少朋友破解过密码，装过系统。后来直到高考结束，家里换新电脑，一年之内将系统从 Win XP 升级到 Win 7，到 Win 10，电脑中密码才正式被拿掉。


高考报考专业时选择计算机专业并非偶然，我是比较早便知道这门课程学的是什么。但比起一些初中高中便开始参加计算机相关比赛的同学，我还差了很远。为了弥补在大学生涯前两年因学车和社团耽误了的学习时间，同时备战秋招。2018 年期间我阅读了不少技术类书籍，买书读书不论从时间上还是金钱上来说都是一件极为奢侈的事，但如果只是把书架上的书的数量来衡量自己的技术功底，那就错了，真正的书架应该在心中，反复地学习、实践，再夯实理论。如果缺乏思考，就会因为不能深刻理解书本中的意义而不能有效地在实际中运用好这些知识，甚至陷入更深的迷茫中。只有把学习和思考结合起来，才能把知识转为己用。在学习工作之余我在 [GitHub](https://github.com/gdut-yy/GitBlogs) 上写起了自己的技术类博客，不断去思考、复核并总结自己所学习到的知识。


关于工作。我目前的岗位是 Java 实习生，也就是俗称的 “程序员”、“开发工程师”，外行人一般难以理解程序员是干什么的，以为是一个高深莫测的行业。其实不然，程序员也分为很多种，我目前的工作的是把客户的需求用代码去进行实现，以减少用户的工作量。进入公司后我被分配进账务小组。业务理解从一开始的简单调整 UI 到涉及打款的 MQ 队列、定时任务的操作等。参与开发是熟悉业务最快的途径，同时阅读源码也是一项非常重要的能力，公司采用模块化架构，持续集成方案，这使得业务得以解耦和便于持续开发。公司为每名新人安排了业务导师，我在导师黄劲的指导下，渐渐熟悉着相关的账务业务。由于汇聚支付是一家第三方支付公司，国家也有出台行业相关的政策，初次接触一些专业名词时常常不知所云，如“备付金”、“出金”、“入账”等，需要抽时间去学习了解。


关于技术。新技术每年都层出不穷，如何进行个人技术选型成了不容忽视的一点，首先是业务中所用到的技术，必然需要熟练掌握，不然工作难以进行，这一定程度上涉及到了公司的技术选型。对于实际的生产环境而言，技术选型并不是炫技和盲目追新。按我的个人理解技术选型通常需要注意以下几点：

1. 实现当前的需求，主要用到哪种技术；
2. 该技术的成熟度如何，是否被广泛使用；
3. 该技术目前由谁支持，是否持续更新或者权威性如何；
4. 该技术的优势和劣势，以及存在的风险；
5. 技术的复杂性如何，当前团队对该技术的熟悉程度和可能需要的时间；

在使用新框架技术的时候，虽然新框架对比旧框架，往往有性能更优和书写更为优雅的优势，并且为我们屏蔽了很多实现细节，但如果不研究学习底层机制的话，哪怕使用得再熟练，也只能永远停留于表面，仅仅停留在“会用”这一步上。对为什么新框架比旧框架更优秀，背后的思想有何异同，框架未来的发展趋势，是否适合于所有场景等问题往往一无所知。虽然这并不影响写业务代码，但从个人角度而言，这并不利于个人技术发展。还有一点，选择往往会存在困惑，所谓“选择困难症”，造成这种现象的原因之一是因为对它们的实现细节还不够了解，在信息匮乏时做选择必然导致焦虑。实际情况下，我们往往需要在信息匮乏的情况下凭借经验做出选择，毕竟人的精力是有限的，不可能做到样样精通。如何在信息匮乏的情况下还能做出正确选择，这跟自身以往的经验是分不开的，知识广度越广，做出正确选择的可能性便越高，这又回到了总结选择经验的环节上。


关于反思。则表达能力可能是技术人员容易忽视的一项能力，也是我需要去增强的能力。以前信息的传播效率太低，在大街上喊一嗓子，最多传一个街区就销声匿迹了，这还得是大嗓门。到了互联网时代，无论是音频还是视频，都可以在瞬间传遍互联网。在这个时代，说话变得如此重要，如果能在公众面前当众演讲，并且感染现场的观众，进而把内容和情绪通过互联网传播出去，那就是一个相当了不起的技能。我曾在一次开发部周四晚技术分享中分享了 Java 8 的 Stream。就选题而言，这应该是一个比较合适的选题，我本人也做了充分的准备。从反映来看差强人意，有不少可以改进的地方，一个是自己事前没有充分考虑到编译器在使用投影仪时的显示问题；另一个是需要提高自己的表达和抓重点的能力，实际分享时可能会由于词不达意而浪费观众的时间和影响分享的效果。争取自己在以后的分享中能做得更好。


关于未来。回首 2018，比赛、春招、秋招、实习一路走过。展望 2019 ，在这新的一年，我将正式毕业，从学校走向社会。在 2019 中，我要在校园课程和实习中找到平衡点，工作业务上提高与产品、测试部分的配合能力，后续的跟进与优化，提高文档规范性（技术文档，图表，周报等）、工作积极性、发现及解决问题能力；生活上。记得某人曾说过：“大学是从改变自身到改变世界的一次转身，这个转身可以不华丽，但不可以不弘毅。”


致谢。最后，要感谢 2018 年中所有家人、朋友、同学以及同事小伙伴们的支持与帮助，让我得以无后顾之忧地成长。感谢互联网，感谢这个时代。这是一个最好的时代，我们做的任何技术共享都有可能为全人类服务。多年以后，中国会诞生比现在更多更伟大的企业，过去五十年，我们享受世界的科技财富太多了，现在是我们要用技术汇报这个世界的时候了。


“伟大背后，皆是苦难。”

- 张逸扬
- 2019 年 1 月于广州