# 《计算机操作系统（第4版）》汤小丹 梁红兵 哲凤屏 汤子瀛 编著

![]()

## 书评

讲授前9章。

## 第一章 操作系统引论
操作系统的基本特性：并发、共享、虚拟和异步。
## 第二章 流程的描述与控制
对于进程的定义，从不同的角度可以有不同的定义，其中较典型的定义有：

- 1）进程是程序的一次执行。
- 2）进程是一个程序及其数据在处理机上顺序执行是所发生的活动。
- 3）进程是具有独立功能的程序在一个数据集合上运行的过程，它是系统进行资源分配和调度的一个独立单位。

进程的特征：

- 动态性
- 并发性
- 独立性
- 异步性

进程的三种基本状态：

- 就绪（Ready）状态。
- 执行（Running）状态。
- 阻塞（Block）状态。

### 2.7 线程（Threads）的基本概念
线程：调度和分派的基本单位

## 第三章 处理机调度与死锁

### 3.2 作业与作业调度
- 先来先服务（first-come first-served，FCFS）
- 短作业优先（short job first，SJF）
- 优先级调度（priority-scheduling algorithm，PSA）
- 高响应比优先调度算法（Highest Response Ratio Next，HRRN）

### 3.3 进程调度
- 非抢占方式
- 抢占方式
 
----

- 轮转调度算法
- 优先级调度算法
- 多队列调度算法
- 多级反馈队列调度算法
- 基于公平原则的调度算法

### 3.5 死锁概述

#### 死锁的定义
如果一组进程中的每一个进程都在等待仅由该组进程中的其它进程才能引发的事件，那么该组进程是死锁的（Deadlock）。

#### 产生死锁的必要条件
虽然进程在运行过程中可能会发生死锁，但产生进程死锁是必须具备一定条件的。综上所述不难看出，**产生死锁必须同时具备下面四个必要条件，只要其中任一个条件不成立，死锁就不会发生**。

- **互斥条件**。进程对所分配到的资源进行排他性使用，即在一段时间内，某资源只能被一个进程占用。如果此时还有其他进程请求该资源，则请求进程只能等待，直至占有该资源的进程用毕释放。
- **请求和保持条件**。进程已经保持了至少一个资源，但又提出了新的资源请求，而该资源已被其他进程占有，此时请求进程被阻塞，但对自己已获得的资源保持不放。
- **不可抢占条件**。进程已获得的资源在未使用完之前不能被抢占，只能在进程使用完时由自己释放。
- **循环等待条件**。

## 第四章 存储器管理

#### 4.3.4 基于顺序搜索的动态分区分配算法

- 首次适应（first fit，FF）算法
- 循环首次适应（next fit，NF）算法
- 最佳适应（best fit，BF）算法
- 最坏适应（worst fit，WF）算法

### 4.5 分页存储管理方式
根据在离散分配时所分配地址空间的基本单位的不同，又可将离散分配分为以下三种：

- 分页存储管理方式
- 分段存储管理方式
- 段页式存储管理方式

### 4.6 分段存储管理方式

分页和分段的主要区别

- 1）页是信息的物理单位。段则是信息的逻辑单位。
- 2）页的大小固定且由系统决定。而段的长度却不固定。
- 3）分页的用户程序地址空间是一维的。分段系统中，用户程序的地址空间是二维的。

## 第五章 虚拟存储器
### 5.3 页面置换算法

- 最佳（Optimal）置换算法
- 先进先出（FIFO）置换算法
- 最近最久未使用（Least Recently Used，LRU）置换算法
- 最少使用（Least Frequently Used，LFU）置换算法
- Clock置换算法



## 第六章 输入输出系统
DMA

假脱机（Spooling）系统

磁盘调度算法

- 先来先服务(FCFS)
- 最短寻道时间优先（SSTF）
- 扫描（SCAN）算法
- 循环扫描（CSCAN）算法
- NStepSCAN 和 FSCAN 调度算法

## 第七章 文件管理

在系统中的所有文件都存在着一下两种形式的文件结构：

- （1）**文件的逻辑结构（File Logical Structure）**。这是从用户观点出发所观察到的文件组织形式，即文件是由一系列的逻辑记录组成的，是用户可以直接处理的数据及其结构，它独立于文件的物理特性，又称为文件组织（File Organization）。
- （2）**文件的物理结构，又称为文件的存储结构**。这是指系统将文件存储在外存上所形成的一种存储组织形式，是用户不能看见的。文件的五里街哦股不仅与存储介质的存储性能有关，而且与所采用的外存分配方式有关。


## 第八章 磁盘存储器的管理

目前常用的外存组织方式有：

- 1）连续组织方式。
- 2）链接组织方式。
- 3）索引组织方式。

## 第九章 操作系统接口
对于一般通用的OS而言，可将系统调用分为如下三大类：

- 1. 进程控制类系统调用
- 2. 文件操纵类系统调用
- 3. 进程通信类系统调用

## // 第十章 多处理机操作系统

## // 第十一章 多媒体操作系统

## // 第十二章 保护和安全