# 《必然》 凯文·凯利 著

## 书评
读于 2019-03-29，广州图书馆。
## 目录
## 作者序
我十三岁时，父亲带我去了新泽西州的大西洋城参观一个计算机展会。那是 1965 年。父亲对那些房间大小的机器感到超级兴奋。这些机器的制造者是诸如IBM之类美国最顶尖的公司。父亲信奉进步论，而那些最早期的计算机便是他想象中的未来一瞥。我当时就像个典型的青少年一样，对此非常不以为然。那些占满巨大展厅的计算机实在无聊。除了以英亩为单位计量大小的长方形铁柜之外，就没什么可看的了。展会中一块屏幕也没有。也没有语音输入和语音输出。这些计算机唯一能做的事情，就是在一排排的折叠纸上打印数字。我在科幻小说中读到了很多关于计算机的描写，而这些展会上的东西都不是“真正”的计算机。

1981 年我在佐治亚大学的一个科学实验室里工作时，得到了一台 AppleII 型计算机。尽管它有一台小小的黑绿两色显示器，可以显示文字，但我对这台计算机的印象也并不深刻。虽然打起字来比打字机好上不少，而且在绘制函数图像和追踪数据方面，这台电脑也是个“行家”，但它还不是一台“真正”的计算机。它并没有给我的生活带来什么改变。

几个月后当我把电话线插进 AppleII 的调制解调器时，我的看法完全改变了。突然间一切都变得不一样——电话插孔的另一端是一个新兴的宇宙，它巨大无比，几乎无垠。那里有在线公告板和实验性的电话会议；这个空间被称作互联网。这根电话线中的传送门开启了一个新的东西：它巨大，同时又能为人类所感知。它让人感到有机而又非凡无比。它以一种个人的方式将人与机器连接起来。我能感觉到我的生活逐渐进入到了另一个层次。

回想起来，我认为在计算机与电话线连接之前，计算机时代并没有真正到来。相互孤立的计算机是远远不够的。直到二十世纪八十年代初，当计算机接入电话线并与之融合为强壮的混合系统，计算的深远后果才真正展开。在那之后的三十年里，通信与计算之间的技术融合已经开始扩散、成长、开花、结果。互联网/Web/移动系统已经从社会的边缘（1981年时人们对这类系统几乎毫不关心）进入到现代全球社会的舞台中心。在过去的三十年里，以这种科技为根基的社会经济经历了跌宕起伏，也见证了这个时代中英雄的兴衰更迭。但很明显，这三十年中所发生的一切都被一些大势所主导。

这些影响广泛的历史趋势至关重要，因为孕育它们的基础环境仍在活跃和发展。这也强烈地预示着，这些趋势将会在未来数十年中持续增长。我们还看不到任何阻止或削弱它们的力量。在本书中，我将会对十二种必然的科技力量加以阐述，而它们将会塑造未来的三十年。

“必然”是一个强烈的措辞。它会引起部分人的警觉——这些人相信，没有什么事情是必然的。他们认为，人类的主观意愿可以、也应当对任何机械的趋势加以扭转和控制。在他们看来，“必然”是我们对自由意志的放弃。而当必然的观点和科技结合在一起时，就像我在本书中所做的一样，对宿命的反对就会变得更加强烈和激昂。有一种对“必然”的定义借用了经典的“倒带”思想实验。这个实验假定我们把历史倒退回时间的开端，让我们的文明一次又一次地从头再来。强必然性是说，无论我们重复多少次，最终都会出现这样的结果：2016 年的青少年们每五分钟就要发一条推文。`但这不是我说的必然。`

我所说的必然是另外一种形式。科技在本质上有所偏好，使得它朝往某种特定方向。在其他条件都相同的前提下，决定科技发展动态的物理原理和数学原理会青睐某些特定的行为。这些偏好仅存在于塑造科技大轮廓的合力中，并不会主宰那些具体而微的实例。譬如，因特网的形态——由网络组成的遍布全球的网络——是一种必然，但我们所采用的因特网的具体实现就不是必然。因特网可能是商业化的，而不是非营利的；它可能是国家的，而不是国际的；它也可能是私密的，而非公开的。长距离传输语音信息的电话系统是必然的，但 iPhone 不是；四轮车辆是必然的，但 SUV 不是；即时信息是必然的，但推特不是。

每五分钟发一条推文并非必然还有另外一层原因。我们处于飞速的变化中；我们发明新事物的速度已经超出了我们“教化”这些新事物的速度。今天，一项科技问世之后，我们需要大约十年的时间才能对其意义和用途建立起社会共识。就推特来说，我们还要五年的时间才能为其找到一个合适的栖身之所。正如我们会弄清楚如何处理无处不在的手机铃声一样（用振动模式！），到那时，今天的种种现象可能都已消失得无影无踪，我们就会认识到它既无必要，也非必然。

`我在本书中所谈及的数字领域中的必然是一种动能，是正在进行中的科技变迁的动能。`过去三十年里塑造数字科技的强劲浪潮还会在未来三十年中继续扩张、加强。这不仅适用于北美，也适用于整个世界。在这本书中我所列举的例证都发生在北美，因为读者会更熟悉它们。但每一个例证，我都可以轻易地找出其在印度、马里、秘鲁或爱沙尼亚的对应事例。例如，数字货币的真正领先者是在非洲和阿富汗——在这些地方，电子货币有时是唯一可用的货币。而在开发移动端分享应用方面，中国已经遥遥领先。尽管表象会受到文化的影响，但其潜在的内因都是一样的。

在过去三十年的网上生活中，我起初是这篇广袤荒野的拓荒者，之后又成为建设这片新大陆的建造者中的一员。我对必然的自信建立在科技发展的深层根基之上。日新月异的高科技板块下是缓慢的流层。数字世界的根基被锚定在物理规律和比特、信息与网络的特性之中。无论是什么地域，无论是什么公司，无论是哪种政体，这些比特和网络的基本成分都会一次又一次地孕育出相似的结果。在本书中，我会尽力揭示出这些科技的根基，因为它们会展示出未来三十年中的持久趋势。

这些转变并不全都受欢迎。由于旧的商业模式失灵，既有的行业将被推翻。行业中的所有职业将会消失，一同消失的还会有一些人的生计。新的职业将会诞生，而这些职业会滋生不公和不满。我在本书中阐述的这些趋势将会挑战现行的司法假设，碰触到法律的边界。数字网络技术动摇了国际边界，因为它本身就是无国界的。它会造成冲突和混乱。当我们面对数字领域中极力向前的新科技时，第一反应可能是退回原位。我们会对它加以阻止、禁止、否认，或者至少会让它变得难用无比。（举个例子，当因特网让音乐和电影的复制变得轻而易举时，好莱坞和音乐产业就开始尽其所能来阻止人们复制。但这全然徒劳。他们只是成功地把顾客变成了敌人。）螳臂挡车只会适得其反。任何禁止的做法最多只能暂时有效，从长远来讲则违背了生产力的发展。

睁大眼睛，以一种警醒的态度来拥抱新科技则要有效得多。我在本书中的意图是揭示数字变化的根基所在。一旦洞察，我们就不用采取对立的态度，而是可以因势利导。我们会更深入地理解，为何大规模复制、大规模跟踪以及全面监控会在这里大行其道。我们也会认识到，基于所有制的商业模式正在发生改变；虚拟现实正在成为现实；我们也无法阻止人工智能和机器人改进和创造新的商业，从而抢走我们现有的工作。这或许和我们最初的动机相悖，但我们应当拥抱这些科技的再造和重组。只有与这些科技协作而非阻挠，我们才能最大程度地获取到科技所要给予我们的。我并不是说要放手不管。我们需要对新兴的发明加以监管——无论是从法律层面还是从技术层面，以避免真正（而非假想）的伤害。我们需要依据这些科技的特性来“教化”、“驯服”它们。但我们必须要深度参与，亲身体验，谨慎接受。唯有如此，这些科技才不会弃我们而去。

变化是必然的。我们现在承认，一切都是可变的，一切都在变化当中——尽管很多变化并不为人所察觉。我们说水滴石穿，而这颗星球上所有的动植物也在以一种超级慢动作演变成为不同的物种。即便是永远闪耀的太阳，也会在天文学的时间表上逐渐褪色，只不过当它发生时，我们早已不复存在。人类的文化和生物学现象也如同一部极其缓慢的幻灯片，在向着某个新的形态移动。

而在今天，我们生活中每一项显著变化的核心都是某种科技。科技是人类的催化剂。因为科技，我们制造的所有东西都处在“形成”的过程中。每样东西都在成为别的东西，从“可能”中催生出“当前”。万物不息，万物不止，万物未竟。这场永无止境的变迁是现代社会的枢轴。

不断变化不仅仅意味着“事物会变得不一样”，它也意味着流程——变化之引擎——比产品更重要。在过去二百年里，我们最伟大的发明恰恰是科学流程其自身，而非某个特定的工具或玩意儿。一旦我们发明了科学方法，就能立即创造出数以千计的神奇事物，而这是用其他方法所做不到的。这种能够产生持续改变和改进的方法性的流程要比发明任何产品都强上百万倍，因为自这种流程发明以来，我们已经借助它生成了数以百万计的新产品。正确掌握这种流程，它就能源源不断地带给我们好处。在我们所处的新时代，流程完胜产品。

永无休止的变化是一切人造之物的命运。我们正在从一个静态的名词世界前往一个流动的动词世界。在未来的三十年里，我们还会继续使用汽车、鞋子这样有形的物体，并会把它们转化成为无形的“动词”。产品将会变成服务和流程。随着高科技的注入，汽车会变成一种运输服务，一个不断更新的材料序列，对用户的使用、反馈、竞争、创新乃至穿戴做出快速的适应。无论这辆车是无人驾驶汽车，还是可以由你驾驶的私家车，这种运输服务生来具有灵活性，它可定制，可升级，可联网，而且可以带来新的便利。鞋子同样不再会是成品，而会成为塑造我们双脚的无尽流程。即便是一次性的鞋子，都会成为服务，不再会是产品。而在无形的数字领域中，没有任何静态的东西，也没有一成不变的事物。所有一切，都在成为其他。

这无情的变迁之上是现代的分崩离析。我见证过无数科技力量的爆发，并从中归纳出了十二个动词。更准确地说，它们不仅仅是动词，还是一种“现在分词”，用来表达“持续动作”的一种语法形式。而这些力量正是处在加速中的动作。

这十二个持续动作中，每一个都是一种正在发生的趋势。所有迹象表明，这些趋势将持续至少三十年。我把这些元趋势称为“必然”，因为它们植根于科技的本质，而非社会的本质。这些动词的特性来源于所有新科技所共有的偏好。虽然作为创造者我们对科技的取向有很多选择和责任，但仍有许多因素是我们无法控制的。特定的技术流程会倾向于特定的产出。比如说工业流程（蒸汽机、化工厂、水坝）会倾向于人体所不适应的高温和高压；而数字科技（计算机、互联网、移动应用）则倾向于大规模廉价复制。工业流程对高温／高压的偏好促使制造的场所离人们越来越远，并向大规模、中心化的工厂演变，这种演变与人类社会的文化、背景和政治因素无关。而数字科技对大规模廉价复制的偏好也同样独立于国家、经济和人类意愿，并使科技转向了大规模社交；这种偏好的背后是数字比特的内在特性。在上述这两个例子中，我们都只有“倾听”科技所偏好的方向，并使我们的期待、管理和产品服从于这些科技所内在的基本趋势，才能从科技中获得最大利益。当我们对科技的利用贴近于科技所偏好的轨迹时，我们才会在管理复杂性、优化利益和减少科技带来的伤害方面更加得心应手。本书的目的便是将这些科技中的最新趋势整理归纳，并将它们的轨迹呈现出来。

这些有机的动词代表着在未来一段时间内都会呈现在我们文化中的一系列元变化。这些元变化已经在当今世界留下了浓墨重彩的描画。我无意预测哪种特定的产品会在来年或者未来十年中走红，也无意预言哪些公司将会胜出。这类结果取决于潮流、时尚和商业等因素，是完全不可预测的。但未来三十年中产品和服务的总趋势则已清晰可见。新兴技术正在席卷全球，这股迅猛的大潮会潜移默化且持续坚定地改变我们的文化。下述力量将会得到凸显：`形成（Becoming）、知化（Cognifying）、流动（Flowing）、屏读（Screening）、使用（Accessing）、共享（Sharing）、过滤（Filtering）、重混（Remixing）、互动（Interacting）、追踪（Tracking）、提问（Questioning）以及开始（Beginning）。`

虽然我对每个动词的论述都独立成章，但这些动词并非独自运作。相反，它们是高度叠加的力量，彼此依存，相互促进。很难只论其一，不及其他。分享既促进流动又有赖于流动；认知需要追踪；屏读和互动不可分离；这些动词本身就在融合，又都处于成为的过程中。它们构成了一个运动的域。

这些力量并非命运，而是轨迹。它们提供的并不是我们将去往何方的预测。它们只是告诉我们，在不远的将来，我们会向哪些方向前行，必然而然。

## 第 1 章 形成（Becoming）

那些未来人说的没错。因为从我们现在的角度来看，本世纪最大的网络事物已经出现在我们面前。只不过那些奇迹般的发明都在等着一个狂人以他的卓识远见来点化我们去采摘那些累累果实——这情形，就像是 1984 年的那些 .com 域名一样。

那些未来人说的没错。因为在 2050 年，会有另外一个白胡子老头问你：你能想象在 2016 年当一个发明家会有多棒吗？那是一片广袤的处女地！你随便找个什么东西，都能加上人工智能，上传到云里面去。那时的设备里不像现在，传感器成千上百，很少有超过一两个的。那时的期望不多，壁垒很低。成为第一轻而易举。

而到那时，未来的人们会感慨：“唉，我们要是意识到那时有多少可能性该多好！”

所以真相就是：此时此刻，今天，2016 年，就是最佳的时机。纵观历史，从来没有哪一天会比今天更适合发明创造。从来没有哪个时代会比当前、当下、此时此刻更有机遇，更加开放，有更低的壁垒、更高的利益风险比、更多的回报和更积极的环境。未来的人们回顾此刻时，会感慨道：“哦，要是活在那时该有多好！”

过去 30 年已经开创了不可思议的起跑线——可以建造真正伟大事物的坚固平台。但即将到来的将会不同，将会超越现在，将会成为他物。而最酷的东西尚未发明出来。 

今天确实是一片广袤的处女地。我们都在“形成”。这在人类历史上，是绝无仅有的最佳开始时机。

你没迟到。

## 第 2 章 知化（Cognifying）

将来，我们和机器人的关系会变得更复杂。同时，一种循环出现的模式值得我们注意。无论你现在从事什么工作，收入水平如何，都将反复经历机器人替代人的以下7个步骤：

    1. 你会说：机器人干不了我的工作
【后来】

    2. 你会说：好吧，它会许多事情，但我做的事情它不一定都会。
【后来】

    3. 你会说：好吧，我做的事情它都会，但它常常出故障，这时需要我来出路。
【后来】

    4. 你会说：好吧，它干常规工作时从不出错，但是我需要训练它学习新任务。
【后来】

    5. 你会说：好吧，就让它做我原来的工作吧，那工作本来就不是人该干的。
【后来】

    6. 你会说：哇，机器人正在干我之前做的工作，我的新工作不仅好玩多了，工资还高！
【后来】

    7. 真高兴，机器人绝对干不了我现在做的事情。
【重复】

这不是一场人类和机器人之间的竞赛，而是一场机器人参与的竞赛。如果和机器人比赛，我们必输无疑 ，哪怕是让人引以为傲的围棋。未来，你的薪水高低将取决于你能否和机器人默契配合。90% 的同事将会是看不见的机器，而没有它们，你的大部分工作将无法完成。任何机器的分工将是模糊的，至少在开始时，你可能不会觉得自己在干一份工作，因为看上去所有的苦差事都被机器人承包了。

我们需要让机器人接手。许多政客极力阻止机器人接手那些人类工作，实际上是人们不情愿干的。机器人能干那些我们正在干的事情，而且远比我们干的好；机器人能从事那些我们从事不了的工作，能做那些我们从没有想到需要去做的工作；机器人还能帮助我们发现自己的新工作，发现那些让我们拓展自身意义的事。

这一切都是必然的。
## 第 3 章 流动（Flowing）
纸书：
- `书页是一成不变的`
- `版本是一成不变的`
- `介质是一成不变的`
- `完成度是一成不变的`

电子书：
- `书页是流动的`
- `版本是流动的`
- `介质是流动的`
- `改进是流动的`

以下就是流动的 4 个阶段：
- `固定、罕见。`最开始的情况，是耗费了大量专业经验创造出来的宝贵产品。这些产品，每一个都如同艺术品一般，完成度高，盈盈独立，通常以高质量产品的形式出售，如此才能补偿创造者付出的艰辛。
- `免费、无所不在。`最早的破坏来自于对第一阶段产品的杂乱复制，其量级之大，使得产品变成了日用品。廉价、完美的复制品近乎免费，哪里有需求，就会在哪里开枝散叶。复制品的过度散播会破坏掉既有的经济。
- `流动、分享。`第二阶段的破坏是对产品的解构，产品拆散后的每一个原件，都会流动寻找新的用途，并和新的产品绑定在一起。第一阶段的产品现在成为了服务信息流。它分享自云端，变成了财富和创新的平台。
- `开放、变化。`前两个阶段引发了第三阶段的解构。强大的服务信息流和既有的“原材料”顺手把成本降低到了一点点，使得业余者只需要很少的专业技能就能创造出新产品和全新品类的产品。创造的地位发生了转变，受众因而成为了艺术家。输出、选择和质量都会突飞猛进。

以上 4 个流动的阶段适用于所有媒介。然而一成不变并未消亡。我们文明中大部分优秀的固定事物（例如道路、摩天大楼）不会走掉。我们会继续制造模拟介质（analog objects）的物品（椅子、盘子、鞋），但它们会吸纳数字特性，同时嵌入芯片（除了那些数量极少但又具有超高价值的史前手工制品）。流体信息流的百花齐放不是做减法，而是做加法的过程。旧的媒介形态延续，新的媒介形态会覆盖其上。最重要的不同在于，一成不变不再是唯一的选项了。好东西不一定是静态不变的。换句话说，正确的不稳定现在成了好事。从停滞到流动，从一成不变到奔流不息，期间的变化并不意味着要放弃稳定性。这是一场对广阔边界的开垦，许多建立在可变性基础上的额外选项都会成为可能。我们正在进行方方面面的探索，从而可以在无止的变化和形态变换的过程里，制造出东西来。
## 第 4 章 屏读（Screening）
## 第 5 章 使用（Accessing）

区块链的一个重要方面还在于它是一种民众公有（public commons）。没有一个人真正拥有它，因为每个人都拥有它。作为一个变得数字化的发明，它也在倾向于变得共享；在它变得共享的同时，它也在变得无主化（ownerless）。当每一个人都“拥有”它时，也就没有人拥有它。实际上，这就是我们通常所指的公有财产或民众公有。我使用道路，但我并不拥有它。我可以随时驶入全世界99%的道路和高速公路（当然也有些例外），因为它们是民众公有。我们通过向当地政府缴纳税费来获取道路的使用权。就我能想到的所有的目的而言，全世界的道路都在为我服务，就好像我拥有它们一样——甚至比我拥有它们还要好，因为我无需负责维护工作。大多数公共基础设施都带给我们这种“胜过拥有”的利益。

去中心化的网络/因特网就是现在的中心化的民众公有。网络的好处在于，它服务于我就像我拥有它一样，而我只需做很少的事情来维护它。我划下手指，就可以随时召唤它。我享受着它令人惊奇的工作能力所带来的全部益处——像天才一样回答问题，像巫师一样到处航行，像行家一样来自娱自乐——而无需承担所有权的负担，只要使用它就够了。（我需要纳税来获得网络的使用权。）我们的社会愈发去中心化，使用性性就会愈发重要。
## 第 6 章 共享（Sharing）
有时，父亲会问我是否曾因不拥有任何东西而感到不踏实、不可靠。我告诉他自己的感觉恰恰相反——我感到自己与原始社会有着深刻的联系。我感觉自己就像一个原始社会中的狩猎者，他穿行于复杂的自然环境中时不会去拥有任何东西，却可以在需要时随时随地地获得一个工具，用完后便将其抛之脑后，继续前行。只有农民才需要一个谷仓来储藏他的财富。数字原住民（注：数字原住民（Digital Natives），哈佛大学网络社会研究中心提出的新概念，指80后以及更年轻的新一代人，他们出生时就面对无所不在的网络世界。——译者注）是自由地奔向前方的，他们不会承受拥有事物所带来的负累，可以自由地探索未知的世界。使用而非拥有事物，使我可以保持敏捷和精力充沛，时刻为即将出现的未知事物做好准备。

----

既然“蜂巢思维”如此愚笨，为什么还要跟它大费周折呢？

因为它既愚笨，但又足够聪明，可以胜任很多工作。

首先，自下而上的“蜂巢思维”总是可以比我们想象的走得更远，甚至超越我们所能相信的程度。只要给予足够的时间，那些去中心化的、相互连接起来的愚笨事物终将会变得比我们预想的更为聪明。

其次，即使这种完全去中心化的力量不能解决我们所有的问题，但它几乎总是开始解决问题的最佳方式。它快速、廉价且不为人所控制。启动一个新的众包服务的门槛很低，而且还在变得更低。“蜂巢思维”可以很快、很平稳地规模化。
## 第 7 章 过滤（Filtering）
## 第 8 章 重混（Remixing）
## 第 9 章 互动（Interacting）
## 第 10 章 追踪（Tracking）
## 第 11 章 提问（Questioning）

我们的社会正在从严格的层级制度向流动的去中心化方向发展。这是个从名词向动词，从可触摸产品向无形生成物，从固定媒体向混杂媒体，从存储向流动，从确定的答案向不确定的问题转变的过程。当然，我们永远需要事实、秩序以及答案发挥作用，它们并没有离开，而是和微生物以及混凝上材料一样，成为文明的大块基石。

但是，最宝贵的方面，也就是生活和技术中最活跃、最有价值以及最多产的那一面，将位于前沿之中，处在充斥着不确定性、混沌、流动性以及各种问题的边缘地带。能够生成答案的技术将继续得到重视，以至于答案会变得即时、可靠、无所不在，并且几乎免费。但是，能够帮助我们生成问题的技术，将获得更多青睐。引擎生成了不安于现状的人类能够探索的新领域、新产业、新品牌、新可能性以及“新大陆”，与此相随，提问机器将会适时出现。

提问比回答更有力量。
## 第 12 章 开始（Beginning）
这种相变过程已经开始。人类会紧密相连并汇入一个全球性母体。我们正义无反顾地向着这个方向前进。这个母体不是人造物，而是一种过程。我们的新型超级网络是一股持久变化的浪潮，不断推动着我们的各种新需求和新欲望。我们完全无法预测30年后身边都有哪些产品、品牌和公司。这些完全取决于个人的机遇和命运。但是这个大规模的、充满活力的过程有着清晰无误的整体方向。未来30年，霍洛斯将沿着与过去30年同样的方向挺进，那就是：更多的流动、共享、追踪、使用、互动、屏读、重混、过滤、知化、提问以及形成。我们正站在开始的时刻。

已经开始。当然，也仅仅是个开始。
