# 《失控：全人类的最终命运和结局》 凯文·凯利 著
![](SHIKONG.jpg)
## 书评
《失控 全人类的最终命运和结局》这是《黑客帝国》主要演员的必读物之一，这本关于机器、系统、生物和社会的"大部头”，揭示了社会进化、特别是互联网发展的"先知预言”，从这本书里，人们可以窥探到SNS的今天和未来。《失控 全人类的最终命运和结局》涉猎：天文、化学、生物、计算机、控制论、运筹学、社会学……　　同时又堪比《黑客帝国》中洞悉未来的"神谕”，正在兴起的"云计算”、"物联网”等都可以在这本写于15年前的书中找到相关的影子。

KK 三部曲 《失控》、《科技想要什么》、《必然》

《新经济 新规则》、《技术元素》
## 目录
## 第 1 章 人造与天生
## 第 2 章 蜂群思维
以下是分布式系统的四个突出特点，活系统的特质正是由此而来：

- 没有强制性的中心控制
- 次级单位具有自治的特质
- 次级单位之间彼此高度连接
- 点对点间的影响通过网络形成了非线性因果关系

----

本书主题之一是论述分布式人造活系统——如并行计算、硅神经网络芯片，以及因特网这样的庞大在线网络等——在向人们展示有机系统的迷人之处的同时，也暴露出它们的某些缺陷。下面是我对分布式系统的利与弊的概述：
群系统的好处：

- `可适应`——人们可以建造一个类似钟表装置的系统来对预设的激励信号进行响应。但是，如果想对未曾出现过的激励信号做出响应，或是能够在一个很宽的范围内对变化做出调整，则需要一个群——一个蜂群思维。只有包含了许多构件的整体才能够在其部分构件失效的情况下仍然继续生存或适应新的激励信号。
- `可进化`——只有群系统才可能将局部构件历经时间演变而获得的适应性从一个构件传递到另一个构件（从身体到基因，从个体到群体）。非群体系统不能实现（类似于生物的）进化。
- `弹性`——由于群系统是建立在众多并行关系之上的，所以存在冗余。个体行为无足轻重。小故障犹如河流中转瞬即逝的一朵小浪花。就算是大的故障，在更高的层级中也只相当于一个小故障，因而得以被抑制。
- `无限性`——对传统的简单线性系统来说，正反馈回路是一种极端现象，比如扩声话筒无序的回啸。而在群系统中，正反馈却能导致秩序的递增。通过逐步扩展超越其初始状态范围的新结构，群可以搭建自己的脚手架借以构建更加复杂的结构。自发的秩序有助于创造更多的秩序——生命能够繁殖出更多的生命，财富能够创造出更多的财富，信息能够孕育更多的信息，这一切都突破了原始的局限，而且永无止境。
- `新颖性`——群系统之所以能产生新颖性有三个原因：（1）它们对“初始条件很敏感”——这句学术短语的潜台词是说，后果与原因不成比例——因而，群系统可以将小土丘变成令人惊讶的大山。（2）系统中彼此关联的个体所形成的组合呈指数增长，其中蕴藏了无数新颖的可能性。（3）它们并不强调个体，因而也允许个体有差异和缺陷。在具有遗传可能性的群系统中，个体的变异和缺陷能够导致恒新，这个过程我们也称之为进化。

群系统的明显缺陷：

- `非最优`——因为冗余，又没有中央控制，群系统的效率是低下的。其资源分配高度混乱，重复的努力比比皆是。青蛙一次产出成千上万只卵，只为了少数几个子代成蛙，这是多么大的浪费！假如群系统有应急控制的话——例如自由市场经济中的价格体系，那么就可以在一定程度上抑制效率低下，但绝不可能像线性系统那样彻底消除它。
- `不可控`——没有一个绝对的权威。引领群系统犹如羊倌放羊：要在关键部位使力，要扭转系统的自然倾向，使之转向新的目标（利用羊怕狼的天性，用爱撵羊的狗来将它们集拢）。经济不可由外部控制，只能从内部一点点地调整。人们无法阻止梦境的产生，只能在它现身时去揭示它。无论在哪里，只要有“涌现”的字眼出现，人类的控制就消失了。
- `不可预测`——群系统的复杂性以不可预见的方式影响着系统的发展。“生物的历史充满了出乎意料。”研究员克里斯·朗顿如是说。他目前正在开发群的数学模型。“涌现”一词有其阴暗面。视频游戏中涌现出的新颖性带给人无穷乐趣；而空中交通控制系统中如果出现涌现的新情况，就可能导致进入全国紧急状态。
- `不可知`——我们目前所知的因果关系就像钟表系统。我们能理解顺序的钟表系统，而非线性网络系统却是道地的难解之谜。后者淹没在它们自制的困思逻辑之中。A导致B，B导致A。群系统就是一个交叉逻辑的海洋：A间接影响其他一切，而其他一切间接影响A。我把这称为横向因果关系。真正的起因（或者更确切地说，由一些要素混合而成的真正起因），将在网络中横向传播开来，最终，触发某一特定事件的原因将无从获知。那就听其自然吧。我们不需要确切地知道西红柿细胞是如何工作的，也能够种植、食用、甚至改良西红柿。我们不需要确切地知道一个大规模群体计算系统是如何工作的，也能够建造、使用它，并使之变得更加完美。不过，无论我们是否了解一个系统，都要对它负责，因此了解它肯定是有帮助的。
- `非即刻`——点起火，就能产生热量；打开开关，线性系统就能运转。它们准备好了为你服务。如果系统熄了火，重新启动就可以了。简单的群系统可以用简单方法唤醒；但层次丰富的复杂群系统就需要花些时间才能启动。系统越是复杂，需要的预热时间就越长。每一个层面都必须安定下来；横向起因必须充分传播；上百万自治成员必须熟悉自己的环境。我认为，这将是人类所要学的最难的一课：有机的复杂性将需要有机的时间。

在群逻辑的优缺点中进行取舍就如同在生物活系统的成本和收益之间进行抉择一样——假如我们需要这样做的话。但由于我们是伴随着生物系统长大的，而且别无选择，所以我们总是不加考虑地接受它们的成本。
## 第 3 章 有心智的机器
以下是由布鲁克斯的移动机器人实验室开发出来的一套普适分布式控制方法：

- 先做简单的事。
- 学会准确无误地做简单的事。
- 在简单任务的成果之上添加新的活动层级。
- 不要改变简单事物。
- 让新层级像简单层级那样准确无误地工作。
- 重复以上步骤，无限类推。

这套办法也可以作为管理任何一种复杂性的诀窍，事实上它也就是用作这个的。

----

布鲁克斯的模型，不仅仅为人工智能领域带来了变革，它也是任何类型的复杂机体得以运作的真正模型。我们在所有类型的活系统中都能看到包容结构和网络层级机制。布鲁克斯总结了设计移动式机器人的5条经验，其表述如下：

- 递增式构建——让复杂性自我生成发展，而非生硬植入
- 传感器和执行器的紧密耦合——要低级反射，不要高级思考
- 与模块无关的层级——把系统拆分为自行发展的子单元
- 分散控制——不搞中央集权计划
- 稀疏通讯——观察外部世界的结果，而非依赖导线来传递讯息
## 第 4 章 组装复杂性
## 第 5 章 共同进化

冯·诺依曼发明了与游戏有关的数学理论。他将游戏定义为一场利益冲突，游戏各方都试图预测其他方的举动，并采取一系列的步骤，以解决冲突。1944年，他与经济学家奥斯卡·摩根斯特恩合写了一本书——《博弈论与经济行为》。他察觉到，经济具有高度共同进化和类似游戏的特性，而他希望以简单的游戏动力学来阐释它。举例说，鸡蛋的价格取决于卖方和买方彼此之间的预期猜测——我出价多少他才能够接受，他认为我会出多少，我的出价应该比我能承受的价位低多少？令冯·诺依曼惊讶的是，这种相互欺诈、相互蒙骗、效仿、映像以及“博弈”的无休止递归一般都能够落实到一个明确的价格上，而不是无限纠缠下去。即使在股市上，当有成千上万的代理在玩着相互预测的游戏时，利益冲突的各方也能迅速达成一个还算稳定的价格。

冯·诺依曼最感兴趣的是想看看自己能否给这种互动游戏找出最理想的策略，因为乍一看来，它们在理论上几乎是无解的。于是他提出了博弈论作为解答。位于加利福尼亚州圣塔莫妮卡市的兰德公司是美国政府资助的智库。那里的研究人员发展了冯·诺依曼的工作，最后列出了4种有关相互猜测游戏的基本变体。每一个变体各有不同的输赢或平局的奖励结构。这4个简单的游戏在技术文献中统称为“社会困境”，但又可以被看作是构造复杂共同进化游戏的4块积木。这4个基本变体是：`草鸡博弈、猎鹿博弈、僵局，以及囚徒困境`。

`“草鸡博弈”`是供鲁莽的青少年玩的游戏。两辆赛车朝悬崖边奔去；后摔出来的司机是赢家。`“猎鹿”`是一群猎手面对的难题，他们必须合作才能把鹿杀死，如果没有人合作的话，那么开小差各自去撵兔子会更好些。他们是在赌合作（高回报）还是背叛（低，但是肯定有回报）吗？`“僵局”`是挺无聊的游戏，彼此背叛收益最高。最后一个“囚徒困境”最有启发性，在20世纪60年代末成为两百多例社会心理学实验的测试模型。

`“囚徒困境”`是由兰德公司的梅里尔·弗勒德于1950年设计出来的。游戏中，两个分别关押的囚犯必须独立决定否认还是坦白罪行。如果两人都认罪，那么两人都会受到惩罚。如果两人都否认的话，则都会被无罪释放。但假如只有一人认罪，那么他就会得到奖励，而另一个则受到惩罚。合作有回报，但如果策略奏效的话，背叛也有回报。你该怎么办呢？
## 第 6 章 自然之流变
## 第 7 章 控制的兴起
## 第 8 章 封闭系统
生物圈一号

生物圈二号

----

当这些生态学家存心装配第一个合成生态的时候，他们尝试着设计了几条他们觉得对于创造任何活的封闭生物系统都非常重要的指导原则。生物圈二号的制造者们把这些原则称为“生物圈原则”。创造生物圈的时候要记住：

- 微生物做绝大部分的工作。
- 土壤是有机体。它是活的。它会呼吸。
- 创造【冗余】（多余）的食物网络。
- 逐步地增加多样性。
- 如果不能提供一种物理功能，就需要模拟一个类似的功能。
- 大气会传达整个系统的状态。
- 聆听系统：看看它要去哪里。
## 第 9 章 “冒出” 的生态圈
## 第 10 章 工业生态学
## 第 11 章 网络经济学
### 11.5 联通所有的一切
新兴网络经济的特点——执行纲要：
在我看来，不久的将来，经济中会有几种模式盛行起来。任何经济方案都需要一份执行纲要。当然，不会是我这份了。下面列出的是我认为的网络经济所具备的一些特征：
- `分布式核心`——公司的边界变得模糊。任务，甚至是财务和制造这样的核心任务，都通过网络分包给合同商，他们再进一步分包出去。所有的公司，从只有一个人的到“财富500强”，变成了一个个由所有权和地理位置都分散的工作中心所组成的社会。
- `适应性技术`——如果不能达到“实时”要求，你就完蛋了。条形码、激光扫描仪、手机、700打头的号码、将数据直接上传到卫星的收银机、点评设备，还有配送货车，这一切都在操控着商品生产。生菜的价格，就如同机票的价格一样，在杂货店货架的液晶屏上闪烁变化着。
- `灵活制造`——需求量更少的商品可以利用更小的机器在更短的周期内生产出来。曾几何时，照片冲洗要在全国有数的几个中心里花上若干个礼拜的时间，现在则可以在任何一个街角的小机器上完成，并且立等可取。模块化的设备，消失了的常规库存，以及计算机辅助设计，使得产品研发周期从几年缩短到几周。
- `批量化的定制`——流水线上生产的都是个性化定制的产品。适用于你所在地区气候的汽车，按照你的习惯进行设定的录像机……所有产品都是按照个人特定需求生产的，但却是按照大批量生产的价格来销售。
- `工业生态学`——闭合回路、无废料、零污染的制造业；可拆解回收的产品；向生物兼容技术的逐步过渡。对违背生物学准则的行为越来越无法容忍。
- `全球会计`——即使是小公司也在某种意义上具有全球性。从地理上说不再存在那种未开发的、未知的经济“前沿”。而博弈之局也从那种“每一个胜利都意味着有人失败”的零和游戏变成了正和游戏。只有那些能够把系统堪称统一整体的玩家才能获得回报。结盟、伙伴关系、协作——哪怕是暂时的甚至是矛盾的，将成为行业根本和规范。
- `共同进化的消费者`——公司培训和教育消费者，而消费者又反过来培训和教育公司。网络文化中，产品变成了可改进的连锁经营店，它随着消费者的不断使用而得到不断改进和进化。想想软件升级和注册的例子。公司成为共同进化的消费者的俱乐部或用户群。一家公司如果不能教育和培训消费者，也就无法从消费者那里学习。
- `以知识为基础`——联网的数据会让所有工作都能更快、更好和更容易地完成。但是，数据是廉价的，且大量充斥在网络上，甚至令人不胜厌烦。你的优势不再体现在“如何完成工作”中，而是在“做什么工作”中。数据可不能告诉你这个，但是知识可以。将知识运用到数据上才是无价之宝。
- `免费的带宽`——接入是免费的，但是接入与不接入的选择则会非常昂贵。你可以在任意时刻给任意人发送任意东西；但是选择给谁发送、发送什么以及何时发送，或者选择在什么时候接收什么则变成了需要动脑子的事情。选择不接入什么成为关键。
- `收益递增`——拥有者，得之。给与者、分享者，得之。先到者，得之。一个网络，其价值增长的速度要超过其用户增加的速度。在非网络经济中，一个公司如果增加了10%的客户，那么它的收入也许会增加10%。但是对于一个网络化的公司来说，譬如电话公司，增加 10%的客户可以为收入带来20%的增长，因为新、老客户之间的对话是按照指数增长的。
- `数字货币`——日常使用的数字货币取代了成捆成沓的纸币。所有的账户都是实时更新的。
- `隐性经济`——创造性的前沿和边缘区域得到扩展，不过，它们现在以一种不可见的方式联结到加密的网络中。分布式核心和电子货币是驱动这种隐性经济的力量。其负面结果是：不规范的经济活动四处萌芽。
## 第 12 章 电子货币
### 12.5 点对点金融与超级小钱
数字货币对于网络经济的蜂群思维的重要影响已经开始显现。我们预计有五方面：
- `加速度`。货币完全脱离物质实体后，流通速度就会加快。它将流通得更远、更快。而货币流通速度增加的效果等同于货币流通量的增加。卫星上天，使全球证券交易能够接近光速不分昼夜地运转，从而使得全球货币量扩大了5%。大范围地使用数字货币将会进一步加快货币流通的速度。
- `连续性`。由黄金、珍贵原料或者纸组成的货币，以固定单位出现，并在固定时间支付。譬如，ATM机吐出的是20美元钞票，诸如此类。尽管你每天都要使用电话，但是一个月只给电话公司付一次钱。这是一种“批量模式”的货币。电子货币是连续流。用阿尔文·托夫勒的话来说，它允许以“点滴的方式从你的电子账户中分分秒秒地流出”，来支付重复发生的费用。只要你挂上电话，电子货币账户就要为这一通话付费，或者这样做怎么样？——在你通话的时候就付费。支付与使用同时发生。随着流通速度的加快，连续电子货币就能接近即时支付。而这会妨碍银行的发展，银行现在的利润有很大一部分是来自于“在途货币”，而即时性令其不复存在。
- `无限互换性`。我们终于有了真正的可塑货币。一旦完全脱离了实体，数字货币就不再局限于单一的传递形式，而是可以愉快地在任何一种最方便的介质中迁移。分立的账单逐渐消失。账目会与服务内容或者服务本身同时出现。录像带的账单可以整合在录像带之中。发票就在条形码中，用激光一扫就可付清。任何一种有电荷的东西，都可用来充值付费。兑换外币变成了变换符号。货币跟数字信息一样具有了可塑性。以前不曾属于经济活动的某些交换和交互可以更容易地使用货币进行。它为商业活动打开了通向互联网之门。
- `可达性`。迄今为止，对货币进行精密周全的操控一直是专业金融机构（金融神父）的私有领域。但是，正如百万台苹果机击溃由高等祭司所卫护垄断的主机电脑，电子货币也将打破金融婆罗门的垄断。想象一下，如果你的图标拖到电子票据上就可以收取（并且收到）你应得的利息；想象一下，如果你能在“应收利息”图标上分解并且设定可变的利息，让它随时间的增加而增长。或者，如果你能够提前发送款项，也许就能按分钟收取利息。或者，在个人电脑上编个程序，让它能够按照银行优惠贷款利率来区别付费——为业余人士把货币交易写成程序。或者可以让电脑追踪汇率，用当前最不值钱的货币支付账单。一旦大众可以和专业人士同饮一江——电子货币这条江——之水，所有这些智能金融工具，就立刻浮出水面。现在，我们也许可以把金融也加入我们的鼓捣对象之中，我们正走向编码资本主义。
- `私有化`。电子货币在获取、交付和产生方面的便利性让它成为私有货币的理想候选。日本电信电话株式会社捆绑在电话卡上的那2140亿日元，只不过是私有货币的一种有限类型。互联网的法则是：只要计算机与电子货币连接，那么谁拥有了计算机，他拥有的就不只是印刷机，还有铸币厂。准货币会突然出现在有信用的任何地方（也会在那里突然消失）。

从历史上看，绝大多数的现代实物交易网络会迅速转向使用货币交易；人们或许认为电子交易组织也会如此，但是，电子货币系统所具有的盲目性却可能不会遵从这一趋势。准货币网络能否浮出水面，是个涉及到3500亿美金税费的问题。

货币的铸造和发行是政府仅存的尚未被私有部门侵占的少数功能之一。电子货币将削弱这难以克服的障碍。这么做，会为私有统治体制提供强有力的工具。这些私有统治体制可能是由反叛民族的团体建立的，也可能是由世界大都市附近迅速增长的“边缘城市”建立的。在全球范围内使用机构电子货币进行洗钱已经超出了任何人的控制。
## 第 13 章 上帝的游戏
## 第 14 章 在形式的图书馆中
## 第 15 章 人工进化
## 第 16 章 控制的未来
## 第 17 章 开放的宇宙
## 第 18 章 有组织的变化之架构
一些计算机专家在用到“学习”这个词时，所指的是一种不严格的、控制论上的概念。格雷戈里·贝特森把躯体的灵活性看作是一种学习。他不认为由躯体进行的搜索和由进化或思维进行的搜索有多大区别。以此解释的话，可以说“灵活的身体学习适应压力”。“学习”应该是在一生而非几代中获得的适应。计算机专家并不对行为学习和肉体学习进行区分。关键是，这两种适应形式都是在个体的一生中对适应空间进行搜索。

生物体在其一生中有很大的空间重塑自己。加拿大维多利亚大学的罗伯特·里德指出，生物能通过以下可塑性来回应环境的变化：

- `形态可塑性`（一个生物体可能有不止一种肉体形态）
- `生理适应性`（一个生物体的组织能改变其自身以适应压力）
- `行为灵活性`（一个生物体能做一些新的事情或移动到新的地方）
- `智能选择`（一个生物体能在过去经历的基础上做出选择）
- `传统引导`（一个生物体能参考或吸取他人的经验）

这里的每一个自由度都代表一个方向，生物体可以沿着它在共同进化的环境中寻找更好的办法重塑自己。考虑到它们是个体在一生中所获得的适应性，并能在以后被遗传同化，因而我们称这五种选项为可遗传学习的5个变种。
## 第 19 章 后达尔文主义

后达尔文主义者已经证明，由一个维度上的自然选择推进的单一进化是不存在的。进化应该是既有宽度，又有纵深的。深度进化是多种进化的聚合，是一位多面的神祗，一位千臂的造物主，他的造物方法多种多样，自然选择也许只是其中最普适的一个方法。深度进化正是由这许许多多尚未明了的进化所构成，就好像我们的心智是一个兼收并蓄的社会一样。不同的进化在不同的尺度上、以不同的节律、用不同的风格运行着。此外，这种混合的进化随时间的推移而改变。某些类型的进化对于早期的原型生命来说很重要，另一些则在40亿年后的今天承担着更重要的责任。某种进化（自然选择）会出现在每一处地方，其他进化则可能只是偶尔一见、起着特定的作用。这种多元化的深度进化，犹如智能，是从某种动态群落中涌现出来的。

当我们构建人工进化来繁育机器或者软件时，也要考虑到进化的这种异质特性。我期待着在具有开放性和可持续创造力的人工进化中看到以下特性（我相信生物进化中也存在着这些特性，但是人工进化会将这些特性表现得更显著）：

- `共生`——便捷的信息交换以允许不同的进化路径汇聚在一起
- `定向变异`——非随机变异以及与环境的直接交流和互换机制
- `跳变`——功能聚类、控制的层级结构、组成部分的模块化，以及同时改变许多特性的适应过程
- `自组织`——偏向于某种特定形态（譬如四轮）并使之成为普遍标准的发展过程

人工进化不能创造一切。虽然我们能够细致无遗地想象出很多东西——而且按照物理和逻辑法则来判断它们也一定能够运转，但由于合成进化自身的束缚，我们无法真的将其实现。
## 第 20 章 沉睡的蝴蝶
## 第 21 章 水往高处流
## 第 22 章 预言机
## 第 23 章 整体，空洞，以及空间、
## 第 24 章 九律
如何无中生有？虽然大自然深谙这个把戏，但仅仅依靠观察她，我们并没学到太多的东西。我们更多地是从构造复杂性的失败中以及从模仿和理解自然系统的点滴成就中学习经验教训。我从计算机科学和生物研究的最前沿成果中以及交叉学科的各种犄角旮旯里提取出了大自然用以无中生有的九条规律——是为九律：

- 分布式
- 自下而上的控制
- 递增收益
- 模块化生长
- 边界最大化
- 鼓励犯错误
- 不求最优化，但求多目标
- 谋求持久的不均衡态
- 变自生变

在诸如生物进化、“模拟城市”等各式各样的系统中都能发现这九律的身影。当然，我并不是说它们是无中生有的唯一律法；但是，由复杂性科学所累积的大量观察中总结出来的这九律是最为广泛、最为明确、也最具代表性的通则。我相信，只要坚守这九律就能够有如神助一般无往而不利。

`分布式`。蜂群意识、经济体行为、超级电脑的思维，以及我的生命都分布在众多更小的单元上（这些单元自身也可能是分布式的）。当总体大于各部分的简单之和时，那多出来的部分（也就是从无中生出的有）就分布于各部分之中。无论何时，当我们从无中得到某物，总会发现它衍生自许多相互作用的更小的部件。我们所能发现的最有趣的奇迹——生命、智力、进化，全都根植于大型分布式系统中。

`自下而上的控制`。当分布式网络中的一切都互相连接起来时，一切都会同时发生。这时，遍及各处而且快速变化的问题都会围绕涌现的中央权威环行。因此全面控制必须由自身最底层相互连接的行动通过并行方式来完成，而非出于中央指令的行为。群体能够引导自己，而且在快速、大规模的异质性变化领域中，只有群体能引导自己。要想无中生有，控制必然依赖于简单性的底层。

`递增收益`。每当你使用一个想法、一种语言或者一项技能时，你都在强化它、巩固它并使其更具被重用的可能。这就是所谓的正反馈或滚雪球。成功孕育成功。这条社会动力学原则在《新约》中表述为：“凡有的，还要加给他更多。”任何改变其所处环境以使其产出更多的事物，玩的都是收益递增的游戏。任何大型和可持续的系统玩的也是这样的游戏。这一定律在经济学、生物学、计算机科学以及人类心理学中都起作用。地球上的生命改变着地球以产生更多的生命。信心建立起信心。秩序造就更多的秩序。既得者得之。

`模块化生长`。创造一个能运转的复杂系统的唯一途径就是先从一个能运转的简单系统开始。试图未加培育就立即启用高度复杂的组织——如智力或市场经济，注定走向失败。整合一个大草原需要时间——哪怕你手中已掌握了所有分块。我们需要时间来让每个部分与其他部分相磨合。通过将简单且能独立运作的模块逐步组装起来，复杂性就诞生了。

`边界最大化`。世界产生于差异性。千篇一律的实体必须通过偶尔发生的颠覆性革命来适应世界，一个不小心就可能灰飞烟灭。另一方面，彼此差异的实体则可以通过每天都在发生的数以千计的微小变革来适应世界，处于一种永不静止却不会死掉的状态中。多样性垂青于那些天高皇帝远的边远之地，那些不为人知的隐密角落，那些混乱时刻，以及那些被孤立的群族。在经济学、生态学、进化论和体制模型中，健康的边缘能够加快它们的适应过程，增加抗扰力，并且几乎总是创新的源泉。

`鼓励犯错误`。小把戏只能得逞一时，到人人会耍时就不灵了。若想超凡脱俗，就需要想出新的游戏，或是开创新的领域。而跳出传统方法、游戏或是领域的举动，又很难同犯错误区别开来。就算是天才们最天马行空的行为，归根结底也是一种试错行为。“犯错和越轨，皆为上帝之安排，”诗人威廉·布莱克这样写道。无论随机还是刻意的错误，都必然成为任何创造过程中不可分割的一部分。进化可以看作是一种系统化的错误管理机制。

`不求最优，但求多目标`。简单的机器可以非常高效，而复杂的适应性机器则做不到。一个复杂结构中会有许多个“主子”，系统不能厚此薄彼。与其费劲将任一功能最优化，不如使多数功能“足够好”，这才是大型系统的生存之道。举个例子，一个适应性系统必须权衡是应该拓展已知的成功途径（优化当前策略），还是分出资源来开辟新路（因此把精力浪费在试用效率低下的方法上。）在任一复杂实体中，纠缠在一起的驱动因素是如此之多，以至于不可能明了究竟是什么因素可以使系统生存下来。生存是一个多指向的目标。而多数有机体更是多指向的，它们只是某个碰巧可行的变种，而非蛋白质、基因或器官的精确组合。无中生有讲究的不是高雅；只要能运行，就棒极了。

`谋求持久的不均衡态`。静止不变和过于剧烈的变化都无益于创造。好的创造就犹如一曲优美的爵士乐，不仅要有平稳的旋律，还要不时地爆发出激昂的音节。均衡即死亡。然而，一个系统若不能在某个平衡点上保持稳定，就几乎等同于引发爆炸，必然会迅速灭亡。没有事物能既处于平衡态又处于失衡态。但某种事物可以处于持久的不均衡态——仿佛在永不停歇、永不衰落的边缘上冲浪。创造的神奇之处正是要在这个流动的临界点上安家落户，这也是人类孜孜以求的目标。

`变自生变`。变化本身是可以结构化的。这也是大型复杂系统的做法：协调变化。当多个复杂系统构建成一个特大系统的时候，每个系统就开始影响直至最终改变其他系统的组织结构。也就是说，如果游戏规则的订立是由下而上，则处在底层的相互作用的力量就有可能在运行期间改变游戏的规则。随着时间的推移，那些使系统产生变化的规则自身也产生了变化。人们常挂在嘴边的进化是关于个体如何随时间而变化的学说。而深层进化——按其可能的正式定义，则是关于改变个体的规则如何随时间而变化的学说。要做到从无中生出最多的有，你就必须要有能自我变化的规则。


## 译后记：“失控”的协作与进化
很多人都会认为这本书过于技术化了，不适合阅读。这的确不是一本轻松的读物。事实上，那些有机会先睹为快的朋友们都告诉我，每读上一小节，他们都要停下来，想一想，甚至还要休息一下。不过，他们也无一例外地表示，这是一部真正有价值的书，是一部思想之书、智慧之书。

这样一部读着都很“辛苦”的书，其翻译过程就更不必说了。但翻译的辛苦，并不是值得在这里大书特书的事情——翻译本就是一件苦差事。这部书的翻译过程之所以与众不同，正在于它身体力行地实践了这本书中的思想。

翻译工作早在2008年5月就开始了。起初只有一位译者——同时身怀清华数学系的学士学位和北大哲学系的准博士学位。我们在评估原作后一致认为，这样一个“大部头”，绝不能采用多人协作的方式，否则很难保证质量。现在回过头来看，这其实也是一个近于“荒谬”的结论。上世纪也曾有很多高质量的译著，是由团队协作完成的。只不过后来，地理上聚在一起的团队不复存在，翻译似乎成了“一个人的战斗”，即使有多人参与，也往往是编辑在时间的压力下将原作分成几块，包给不同的译者分头完成而已。译者间绝少通气和交流，因而也不能称之为“协作”，并且质量也无法得到保证。

到了2008年底，《失控》的翻译进度远远落后于计划——只完成了初稿的四分之一左右。无奈之下，我决定铤而走险，通过社区公开招募的方式，选拔了另外8名译者。这些译者中，有大学生，有中学教师，有大学老师，有国家公务员，更多的其实连做什么我都不是很清楚。他们与之前的译者组成一个虚拟团队，以协作的方式继续工作。为此，我们创建了维基页面和Google小组。

协作一开始就处在一种“失控”的状态：章节段落是自由认领的，译者们喜欢哪一章就在维基页面那章的标题后面注上自己的ID。有的译者只小心翼翼地认领半章；也有的译者死乞白赖地求手快的译者把喜欢的章节让给自己。作为协作翻译的组织者，我只是维护一张表格，每周向大家汇报进度而已。虽然感觉上有些乱哄哄的，不过也没出什么大问题，每周的进度也很令人满意。

很快新的问题又冒出来了。有些译者将翻译过程中遇到的难点发到Google小组里，引起了争论，并且常常谁都很难说服谁。这时候我觉得有必要设立某种仲裁机制了，于是提出由大家推举三位译者组成仲裁小组，作为最终的裁定机构。想不到的是，我的提议竟然遭到了所有译者的反对。“不，我们自己能摆平这些问题！”好吧，于是我缩回去继续做我那份很有前途的进度汇报工作。

仅仅用了一个半月的时间（中间还过了一个春节），全书的初稿就奇迹般地完成了。鉴于之前的组织工作实在“混乱”，也不“规范”——譬如说，事先并没有一个统一的术语表，只是译者们在翻译过程中觉得哪些术语有必要统一，就把它们添加到一个维基页面上；但其他译者是否认可和遵从，也没有强制约束——因此，大家一致同意进入互校阶段（事实上，有些手快的译者在此之前已经完成了一遍对自己那部分的自校工作）。

互校中也免不了吵吵闹闹。但还有更“节外生枝”的事情发生。一位译者用了一周时间，将书中所涉及的过百个人物在互联网上检索了一遍，做了注释；另一位译者列出了他认为对理解本书来说至关重要的三十几个关键词；还有几个译者从自己的专业背景出发，结合从维基百科、互动百科上查到的词条，为专业术语做了加注。大家今天看到的这本中文版中，注解多达400多个！这正是译者们的工作成果。

两轮互校完成后，大家又推举了一位译者对全书文字做了润色。到2009年5月，这种“蜂群思维”式的协作基本上告一段落。第一版的中文《失控》诞生了。那时候，全部的译文都放在维基页面上，并且谁都可以看到。现在网上能找到的《失控》译文，基本上都是那个版本的节选和转载。

这之后，我决定由我对全书再做一次终校，以进一步提升质量。谁曾想，这一校就是一年多。其间经历了我被迫离开联合创业并担任总经理的公司，从头建设一个新的网站和社区——“东西”。好在团队承担了绝大部分工作，社区也给了我莫大的鼓励和帮助。我得以在这一年多的时间里，时断时续地完成了终校工作。说是完成，其实也不确切，最终还是未来得及对第22章和第23章进行终校。因此，这一版的中译本还算不上完美，还有很大的进化空间。

终校的“拖沓”，在我看来并不能算是“失败”，它从某种程度上再次验证了《失控》中所提及的思想，并让我们更深刻地认识了“众包”这一互联网经济时代的新模式。

如果说终校之前的协作是在一个扁平层级上的“蜂群思维”，那么终校则是在这个层级之上的更高级行为。这里的层级不是阶级的层级，而是功能的层级。正所谓“革命只有分工不同，没有高低贵贱之分”。

理想状态下，高层级的行为不应简单重复低层级的行为。“终校”与其说是“校”，不如说是“读”。我依靠自身的知识背景，通读译文，遇到别扭或难解之处，再去对照原文。不过在这个过程中，我发现译文的质量参差不齐，一些章节不得不近于重翻一遍。但这并不是译者们的问题，而是因为在08年底的时候，我们还没有能力通过社区招募到这么多能够充分胜任《失控》这本书的译者。

即便在两年后的今天，我们也不敢保证能够通过社区招募到数量恰恰好、水平恰恰够、文风足够近的译者来组成一个完美的协作团队。而且我相信，不论是现在还是将来，达成这个目标的几率都几乎为零。

这也就是“众包”的特点——带有一定的不确定性和不可控性。

在继续讨论“众包”模式之前，先澄清一个曲解。“众包”不是“威客”。借助网络从茫茫人海中筛选出最突出的个体来完成任务，这其实是“超女”的海选；没有了协作，没有了“蜂群思维”，也就不成其为“众包”。

不确定性往往使人们感到不安，而不可控性更是被视为现代企业管理的大敌。然而从另一方面讲，不确定性和不可控性也正是创新的源泉、进化的动因。这点毋需我来赘述。

如何既不抹杀创造性和进化空间又能保证产品和服务的质量？

答案就是层级架构，而且往往只需要两个层级就足够了：下层是充满活力的“蜂群”式协作，上层则对产品或服务的最终质量进行把控。《失控》中用了一个相对专业的术语来描述这种结构——包容架构；其所涉及的细节和故事，也要比我这里的三言两语丰富得多。

《连线》编辑 Jeff Howe 最初在06年提出“众包”的时候，认为是网络和科技产品的进步——譬如数码相机——使得原本需要专业人士才能完成的工作由业余人员就可以完成，并且在海量的业余作品库中，总有一款适合你。

四年之后，我们相信，“众包”需要重新定义。

Jef Howe 的立论基础并非今天所特有。历史上每一次重大的科技进步，都会将某个原本高高在上的行业或技能“贬值”为大路货，譬如书写。只不过今天，科技发展如此迅速，使得成千上万的行业和技能在瞬间就从“专业”的顶峰跌入“业余”的谷底，让那些专业人士们无所适从。而至于说海量的内容库，拜托，我们已经在为信息过载而头疼了。

因而，我们在这里所说的“众包”，是以“蜂群思维”和层级架构为核心的互联网协作模式。嗯，就是这样。

好了，感谢你耐心地读到这里，而不是一看见“后记”这样的字眼就一把把这几页纸撕掉——我听过不止一个人表达过类似的强烈愿望。

感谢参与《失控》协作翻译的译者们：陆丁、袁璐、陈之宇、郝宜平、小青、张鹃、张行舟、王钦、顾珮钦、卢蔚然、gaobaba；感谢“东西”团队：傅妍冰（西西）、张文武（铁蜗牛）、师北宸、郝亚洲、王懿、管策、周峰、张宁、杜永光、左向宇、任文科（Kevin.Ren）、王萌（Neodreamer）；还要感谢曾协助校对的金晓轩。

感谢鼓励和帮助我一路走来的朋友们：张向东、毛译敏（毛毛）、刘刚。

更要感谢 KK 对我们的包容和支持。

也期待《失控》中译本在你我的手上继续进化！

赵嘉敏（拙尘）

2010年11月于北京