# 《分布式服务框架原理与实践》 李林锋 著

## 书评

## 目录

## 第 1 章 应用架构演进
## 第 2 章 分布式服务框架入门
## 第 3 章 通信框架
## 第 4 章 序列化与反序列化
## 第 5 章 协议栈

## 第 6 章 服务路由
> 分布式服务框架上线运行时都是集群组网，这意味着集群中存在某个服务的多实例部署，消费者如何从服务列表中选择合适的服务提供者进行调用，这就涉及到服务路由。分布式服务框架要能够满足用户灵活的路由需求。
## 第 7 章 集群容错
> 集群服务调用后失败后，服务框架需要能够在底层自动容错，容错策略很多，分别适用于不同场景。本章将对集群容错的功能和设计进行详细讲解。
## 第 8 章 服务调用
> 除了常用的同步服务调用之外，分布式服务框架还需要支持其他几种形式的服务调用，本章将对这些调用方式进行详细讲解。
## 第 9 章 服务注册中心
> 对于服务提供者，它需要发布服务，由于应用系统的复杂性，服务的数量、类型不断膨胀；对于服务消费者，它最关心的是如何获取到它所需要的服务。对于服务提供方和服务消费方来说，它们还有可能兼具这两种角色：既需要提供服务，又需要消费服务。
>
> 如何有效地管理服务订阅/发布，避免硬编码地址信息时分布式服务框架需要解决的一个问题。通过将服务统一管理起来，可以有效地优化内部应用对服务发布/使用的流程和管理，服务注册中心就是专门用来管理服务订阅/发布的配置管理节点。
## 第 10 章 服务发布和引用
> 服务提供者需要支持通过配置、注解、API 调用等方式，把本地接口发布成远程服务；对于消费者，可以通过对等的方式引用远程服务提供者，实现服务的发布和引用。
## 第 11 章 服务灰度发布
> 灰度发布是指在黑与白之间，能够平滑过渡的一种发布方式。AB test 就是一种灰度发布方式：让一部分用户继续用 A，一部分用户开始用 B；如果用户对 B 没有什么反对意见，那么逐步扩大范围，把所有用户都迁移到 B 上面来。灰度发布可以保证整体系统的稳定，在初始灰度的时候就可以发现、调整问题，以保证其影响度。
## 第 12 章 参数传递
> 服务消费者和提供者之间进行通信时，除了接口定义的请求参数，往往还需要携带一些额外参数，例如产生消息提供者的 IP 地址、消息调用链的跟踪 ID 等；这些参数不能通过业务接口来进行传递，需要底层的分布式服务框架支持这种参数传递方式。
## 第 13 章 服务多版本
> 服务上线之后，随着业务的发展需要对功能进行变更，或者修复线上的 BUG；服务升级之后，往往需要对服务采用多版本管理。服务多版本管理是分布式服务框架的重要特性，它涉及服务的开发、部署、在线升级和服务治理。

OSGi
## 第 14 章 流量控制
> 当资源成为瓶颈时，服务框架需要对消费者做限流，启动流控保护机制。流量控制有多中策略，比较常用的有：针对访问速率的静态流控、针对资源占用的动态流控、针对消费者并发连接数的连接控制和针对并行访问数的并发控制。
## 第 15 章 服务降级
> 大促或者业务高峰时，为了保证核心服务的 SLA（Service-Level Agreement的缩写，意思是服务等级协议），往往需要停掉一些不太重要的业务，例如商品评论、论坛或者粉丝积分等。
>
> 另外一种场景就是某些服务因为某种原因不可用，但是流程不能直接失败，需要本地 Mock 服务端实现，做流程放通。以图书阅读为例，如果用户登录余额鉴权服务不能正常工作，需要做业务放通，记录消费话单，允许用户继续阅读，而不是返回失败。
>
> 上述两种场景，都使用到了分布式服务框架的一个重要服务治理功能：服务降级。服务降级主要包括`容错降级`和`屏蔽降级`两种模式。
## 第 16 章 服务优先级调度
> 当系统当前资源非常有限时，为了保证高优先级的服务能够正常运行，保障服务 SLA，需要降低一些非核心服务的调度频次，释放部分资源占用，保障系统的整体运行平稳。
>
> 服务优先级的调度策略非常多，对于分布式服务框架而言，需要能够支持服务发布时设置优先级策略，并在资源成为瓶颈时，按照用户配置的优先级策略调度执行服务。
## 第 17 章 服务治理
## 第 18 章 分布式消息跟踪
> 随着业务分布式架构的发展，系统间的系统调用日趋复杂，以电商的商品购买为例，前台界面的购买操作涉及到底层上百次服务调用，涉及到的中间件包括：
>
> - 分布式服务框架
> - 消息队列
> - 分布式缓存
> - 分布式数据访问中间件
> - 分布式文件存储系统
> - 分布式日志采集
> - 其他······
> 
> 如果无法有效清理后端的分布式调用和依赖关系，故障定界将会非常困哪。利用分布式消息跟踪系统可以有效解决服务化之后系统面临的运维挑战，提高运维效率。

## 第 19 章 可靠性设计

> 相对于传统的本地 Java API 调用，跨进程的分布式服务调用面临的故障风险更高。
>
> 1）网络类故障：链路闪断、读写超时等。
> 2）序列化和返序列化失败。
> 3）畸形码流。
> 4）服务端流控和拥塞保护导致的服务调用失败。
> 5）其他异常······
>
> 对于应用而言，分布式服务框架需要具备足够的健壮性，在平台底层能够拦截并向上屏蔽故障，业务只需要配置容错策略，即可实现高可靠性。

## 第 20 章 微服务架构
> 过去十年，SOA（Service-Oriented Architecture）架构得到了广泛的应用，现在，随着云计算、移动互联网、Docker容器等技术的快速发展和应用，“微服务”架构（Micro Service Architecture）这一全新的架构风格越来越受到大家的关注，也有越来越多的企业和平台服务提供商在实践中尝试并使用它来解决具体业务问题，微服务架构的流行已经成为未来技术发展趋势之一。
## 第 21 章 服务话最佳实践
> 在服务化之前，业务通常都是本地 API 调用，本地方法调用性能损耗较小。服务化之后，服务提供者和消费者之间采用远程网络通信，增加了额外的性能损耗，业务调用的时延将增大，同时由于网络闪断等原因，分布式调用失败的风险也增大。如果服务框架没有足够的容错能力，业务失败率将会大幅提升。
>
> 除了性能、可靠性等问题，跨节点的事务一致性问题、分布式调用带来的故障定界困难、海量微服务运维成本增加等也是分布式服务框架必须要解决的难题。本章节我们将对服务化之后面临的挑战进行分析，并给出解决方案和业务最佳实践。

使用最终一致性替代传统的强一致性。
