## 题目描述
Bytedance Effciency Engineering 团队在8月20日搬入了学清嘉创大厦。为庆祝团队的乔迁之喜，字节君决定邀请整个 EE 团队，举办一个大型团建游戏——字节跳动大闯关。可视遇到了一个问题：

EE 团队共有 n 个人，大家都比较害羞，不善于与陌生人交流。这 n 个人每个人都向字节君提供了自己认识的人的名字，不包括自己。如果 A 的名单里有 B，或 B 的名单里有 A，则代表 A 与 B 互相认识。同时如果 A 认识 B，B 认识 C，则代表 A 与 C 也会很快的认识，毕竟通过 B 的介绍，两个人就可以很快互相认识的了。

为了大闯关游戏可以更好地团队协作、气氛更活跃，并使得团队中的人可以尽快的相互了解、认识和交流，字节君决定根据这个名单将团队分为 m 组，每组人数可以不同，但组内的任何一个人斗鱼组内的其他所有人直接或间接的认识和交流。如何确定一个方案，使得团队可以分成 m 组，并且这个 m 尽可能地小呢？
## 输入描述
第一行一个整数n，代表有n个人，从1开始编号。

接下来有 n 行，第 x+1 行代表编号为 x 的人认识的人的编号 k（1<=k<=n），每个人的名单以 0 代表结束。

## 输出描述
一个整数m，代表可以分的最小的组的个数。

## 示例1
### 输入
	10
	0
	5 3 0
	8 4 0
	9 0 
	9 0 
	3 0
	0 
	7 9 0
	0 
	9 7 0
### 输出
	2
### 说明
	1号同学孤独的自己一个组，因为他谁也不认识，也没有人认识他。
	其他所有人均可以直接或间接的认识，分在同一个组。

## 备注：
	对于 50% 的数据，n<=1000
	对于 100% 的数据，1<=n<=100000，名单总长度不超过 100000

----

并查集

	#include <stdio.h>
	#define N 100020
	
	int friends[N]; // 每个人所属的连通分量，即构成朋友树时每个人的父节点
	int rank[N];    // 连通分量的权值，即朋友树的大小
	int res;
	
	// 初始化 initialization
	void init(int n) {
	    for(int i=0; i<n; i++) {
	        friends[i]=i;
	        rank[i]=0;
	    }
	}
	
	// 寻找x所属的朋友树的根节点
	int findRoot(int x) {
	    // 一直向上遍历寻找根节点
	    while(x != friends[x]) {
	        x = friends[x];
	    }
	    return x;
	}
	
	void connect(int x,int y) {
	    int xRoot = findRoot(x);
	    int yRoot = findRoot(y);
	    if(xRoot == yRoot) {
	        return ;
	    }
	    // 判断树高，小树并在大树下
	    if(rank[xRoot] < rank[yRoot]) {
	        friends[xRoot]=yRoot;
	    } else {
	        friends[yRoot] = xRoot;
	        //两树高相等，合并后树高+1
	        if(rank[xRoot]==rank[yRoot]) {
	            rank[xRoot]++;
	        }
	    }
	    --res;
	}
	int main() {
	    int n;
	    init(N);    //初始化
	    scanf("%d",&n);
	    res = n;
	    for(int i=1; i<=n; i++) {
	        int t;
	        while(~scanf("%d",&t)) {
	            if(t == 0)
	                break;
	            connect(i,t);
	        }
	    }
	    printf("%d",res);
	
	    return 0;
	}
