## 题目描述

一天，小凯同学震惊的发现，自己屋内的PM2.5指标是有规律的！小凯采样了PM2.5数值，发现PM2.5数值以小时为周期循环，即任意时刻的PM2.5总是和一小时前相等！他的室友小文同学提出了这样一个问题，在t小时内的所有采样点中，选取若干采样点的数值，能否找到一个PM2.5不曾下降过的序列？这个序列最长是多少？

## 输入描述
第一行有两个整数n和t，表示每小时的采样点个数，和询问多少个小时的结果。

第二行有n个整数，以空格分隔，表示一个小时内，每个采样点观测到的PM2.5数值。

## 输出描述

一个整数，表示T小时内，最长的PM2.5不曾下降过的序列的长度。

## 示例1
### 输入
	4 3
	10 3 7 5

### 输出
	4
### 说明
	3小时内的所有采样点为
	10 3 7 5 10 3 7 5 10 3 7 5
	选取第 2,3,5,9个采样点，可以得到一个不曾下降过的序列
	3 7 10 10
	使用其他的方法也可以得到长为4的免租条件的序列，但无法得到长度超过4的结果。

### 备注

	对于20%的数据，t=1
	对于50%的数据，t<=1000
	对于80%的数据，PM2.5数值不超过200
	对于100%的数据，1<=n<=1000，1<=t<=1000000，PM2.5数值为正整数，且不超过1000000000

----

### 思路： 
本来是在全局序列之中求最长上升子序列,但是因为是重复的序列， 

其实只需在第一个序列之中求最长上升序列，并且其中的最大元素在后面的每个序列之中一定存在，最后加上b-1(b为重复序列个数) 

ans[] 存储给定序列 

tmp[i] 表示从第0位到第i位的最长子序列个数

	#include <iostream>
	#include <vector>
	#include <algorithm>
	using namespace std;
	
	int main() {
	    int a,b;
	    scanf("%d%d", &a, &b);
	    vector<int> ans(a, 0),tmp(a,1);
	    for (int i = 0; i<a; i++) {
	        scanf("%d", &ans[i]);
	    }
	    for (int i = 1; i<a; i++) {
	        for (int j = 0; j<i; j++) {
	            if (ans[i]>=ans[j]) {
	                tmp[i] = max(tmp[i], tmp[j] + 1);
	            }
	        }
	    }
	    cout << *max_element(tmp.begin(), tmp.end())+b-1;
	    return 0;
	}
