# 区间统计

## 题目描述

小明拿到一个数列a1, a2, ... an, 小明想知道存在多少个区间[l, r]同时满足下列两个条件：

1、r-l+1=k;

2、在al,al+1,...ar中，存在一个数至少出现了t次。

输出满足条件的区间个数。

## 输入

输入第一行三个整数n，k，t（1<=n,k,t<=10^5）

第二行 n 个整数，a1, a2, ... an（1<=ai<=10^5）

## 输出

输出一个数，问题的答案。

## 样例输入

	5 3 2
	3 1 1 1 2

## 样例输出
	3

## Hint
	区间[1, 3]中1出现了2次，区间[2, 4]中1出现了3次，区间[3, 5]中1出现了2次。所以一共有3个区间满足条件。

----

第二题开了一个unordered_map记录从0开始每个数字在k长的区间里出现的次数，用另一个map记录相应的超过t的个数。然后往右滑动区间，相当于最左边数字出现的次数-1，最后边的数字出现次数+1。两个数字都判断是否对超过t的数字个数产生影响，常数时间就可以得到从1,2.。。开始的k长度区间里面是否有超过t个数字。总复杂度O(k)

	作者：不觉晓龙
	链接：https://www.nowcoder.com/discuss/104596
	来源：牛客网
	
	#include <iostream>
	#include <algorithm>
	#include <queue>
	#include <string>
	#include <sstream>
	#include <map>
	#include <set>
	#include <stack>
	#include <vector>
	#include <unordered_map>
	#include <unordered_set>
	#include <functional>
	#include <numeric>
	using namespace std;
	 
	int main(){
	    int n, k;
	    cin >> n >> k;
	    vector<int> dp{ 0 };
	    int num;
	    for (int i = 1; i <= n; i++){
	        cin >> num;
	        if (num == 0) dp.push_back(i);
	    }
	    dp.push_back(n + 1);
	    if (k >= dp.size() - 1){
	        cout << n << endl;
	        return 0;
	    }
	    int res(0);
	    for (int i = k + 1; i < dp.size(); i++){
	        res = max(res, dp[i] - dp[i - k - 1] - 1);
	    }
	    cout<<res<<endl;
	    return 0;
	}