
## 题目描述

小易很喜欢斑马，因为它们身上黑白相间的花纹。

一天小易得到了一串橡皮泥，这串橡皮泥只有黑色和白色，小易想把这串橡皮泥重新拼凑一下，让这个橡皮泥串中最长的连续的黑白相间的子串最长，但是小易有强迫症，所以他可以对橡皮泥串进行以下的操作0次或多次：

把橡皮泥串从某个地方切割开，将两个得到的两个串同时翻转，再拼接在一起。

这个橡皮泥串可能太长了，所以小易没有办法计算最终可以得到的最长的连续的黑白相间的子串的长度，希望你能帮他计算出这个长度。

## 输入描述

一个字符串s，只包含字母'b'和字母'w'，分别表示黑色和白色的橡皮泥块。

满足 1 <= |s| <= 10^5，|s|代表字符串的长度。

## 输出描述

一个整数，表示改变之后最长的连续的黑白相间的子串长度。

## 示例1
### 输入
	bwbwb
### 输出
	5
## 示例2
### 输入
	wwb
### 输出
	3

----

	作者：NotDeep
	链接：https://www.nowcoder.com/discuss/105576?type=0&order=0&pos=5&page=1
	来源：牛客网

### 分析
可以发现，无论操作多少次，总是由两段下标连续的串组成，所以直接在原串后面接上原串，求最长黑白相间连续串即可。

### 时间复杂度
O(|S|),其中|S|表示字符串长度

### 参考代码

	#include <bits/stdc++.h>
	using namespace std;
	 
	int main() {
	    string s;
	    cin >> s;
	    s += s;
	    int ans = 1;
	    for (int i = 0; i < s.size(); i++) {
	        int j = 1;
	        while (i != s.size() - 1 && s[i] != s[i + 1]) {
	            i++;
	            j++;
	        }
	        ans = max(ans, j);
	    }
	    if (s.size() / 2 < ans) {
	        ans = s.size() / 2;
	    }
	    printf("%d\n", ans);
	    return 0;
	}