
## 题目描述

随着又一届学生的毕业，社团主席换届选举即将进行。

一共有n个投票者和m个候选人，小易知道每一个投票者的投票对象。但是，如果小易给某个投票者一些糖果，那么这个投票者就会改变他的意向，小易让他投给谁，他就会投给谁。

由于小易特别看好这些候选人中的某一个大神，这个人的编号是1，所以小易希望能尽自己的微薄之力让他当选主席，但是小易的糖果数量有限，所以请你帮他计算，最小需要花多少糖果让1号候选人当选。某个候选人可以当选的条件是他获得的票数比其他任何候选者都多。

## 输入描述
第一行两个整数n和m，表示投票者的个数和候选人的个数。

接下来n行，每一行两个整数x和y，x表示这个投票者的投票对象，y表示需要花多少个糖果让这个人改变意向。

满足 1 <= n，m <= 3000， 1 <= x <= m，1 <= y <= 10^9。
## 输出描述
一个整数，糖果的最小花费

## 示例1
### 输入
	1 2
	1 20
### 输出
	0
## 示例2
### 输入
	5 5
	2 5
	3 5
	4 5
	5 6
	5 1
### 输出
	6

----

	作者：NotDeep
	链接：https://www.nowcoder.com/discuss/105576?type=0&order=0&pos=5&page=1
	来源：牛客网

### 分析
暴力枚举这个人需要多少人支持才能当选，每次枚举时，超出这个数量以及和这个数量相等的人一定需要被改变，之后数量不足，再从剩下的人中选择。

### 时间复杂度
O(m n logn)

### 参考代码

	#include <bits/stdc++.h>
	using namespace std;
	typedef long long ll;
	const int N = 3005;
	 
	vector<int> G[N];
	int vis[N];
	int main() {
	    int n, m;
	    scanf("%d%d", &n, &m);
	    ll ans = 1e18;
	    for (int i = 0;i < n;i++) {
	        int p, c;
	        scanf("%d%d", &p, &c);
	        G[p].push_back(c);
	        vis[p]++;   
	    }
	    int mx = 0;
	    for (int i = 1;i <= m;i++) {
	        if (vis[i] > mx) {
	            mx = vis[i];
	        }
	    }
	    int cnt = 0;
	    for (int i = 1;i <= m;i++) {
	        if (vis[i] == mx) cnt++;
	    }
	    if (cnt == 1 && vis[1] == mx) return 0*puts("0");
	    for (int i = 1; i <= m; i++) sort(G[i].begin(), G[i].end());
	    for (int i = n; i >= 1; i--) {
	        vector<int> r;
	        int num = i - vis[1];
	        ll sum = 0;
	        for (int j = 1; j <= m; j++) {
	            if (vis[j] >= i && j != 1) {
	                int tmp = vis[j] - i + 1;
	                for (int k = 0; k < min(tmp, (int)G[j].size()); k++) {
	                    r.push_back(G[j][k]);
	                }
	            }
	        }
	        for (int j = 0; j < r.size(); j++) {
	            num--;
	            sum += r[j];
	        }
	        if (num <= 0) {
	            ans = min(ans, sum);
	            continue;
	        }
	        r.clear();
	        for (int j = 1; j <= m; j++) {
	            if (vis[j] >= i && j != 1) {
	                int tmp = vis[j] - i + 1;
	                if (tmp >= G[j].size()) continue;
	                for (int k = tmp; k < G[j].size(); k++) {
	                    r.push_back(G[j][k]);
	                }
	            }
	        }
	        for (int j = 1; j <= m; j++) {
	            if (vis[j] < i && j != 1) {
	                for (int k = 0; k < G[j].size(); k++) {
	                    r.push_back(G[j][k]);
	                }
	            }
	        }
	        sort(r.begin(), r.end());
	        for (int j = 0;j < r.size();j++) {
	            num--;
	            sum += r[j];
	            if (num <= 0) break;
	        }
	        if (num <= 0) ans = min(ans,sum);
	    }
	    cout << ans << endl;
	    return 0;
	}