# UTF-8校验

## 题目描述

一个UTF-8字符的长度可能是1到4个字节。其编码规则如下：

对于1字节长的UTF-8字符，第一个bit是0，后面的bit都是它的unicode码；
对于n字节长的UTF-8字符，前n个bits都是1，第n+1 bit是0，接下来的n-1个字节的前两个bits都是10。

例如：

	Char.number range     |    UTF-8 octet sequence
	  (hexadecimal)       |      (binary)
	----------------------+------------------------------------
	0000 0000 ~ 0000 007F | 0xxxxxxx
	0000 0080 ~ 0000 07FF | 110xxxxx 10xxxxxx
	0000 0800 ~ 0000 FFFF | 1110xxxx 10xxxxxx 10xxxxxx
	0001 0000 ~ 0010 FFFF | 11110xxx 10xxxxxx 10xxxxxx 10xxxxxx

给定一个整数数组表示的数据，判断其是否是合法的UTF-8编码。

注意：每个整数只有最低8位用于存储数据。即：输入的每个整数代表一个byte

## 输入描述
第一行一个整数，代表数组长度N

第二行空格分隔的N个整数
## 输出描述
1代表合法，0代表不合法
## 示例1
### 输入
	2
	197 130
### 输出
	1
## 示例2
### 输入
	3
	235 140 44
### 输出
	0

----

	import java.util.Scanner;
	
	/*UTF-8*/
	public class Main4 {
	
	    public static void main(String[] args) {
	        Scanner scan = new Scanner(System.in);
	        int n = scan.nextInt();
	        int a[] = new int[n];
	        for (int i = 0; i < n; i++) {
	            a[i] = scan.nextInt();
	        }
	
	        System.out.println(numOfUtf(a));
	
	    }
	
	    public static int numOfUtf(int[] a) {
	        int i = 0;
	        while (i < a.length) {
	
	            int ones = 0;
	            while (((a[i] >> (7 - ones)) & 1) == 1) {
	                ones++;
	            }
	            if (ones == 1 || ones > 4)
	                return 0;
	            i++;
	            while (ones-- > 1) {
	                if (i >= a.length || ((a[i] >> 6) & 3) != 2)
	                    return 0;
	
	                i++;
	            }
	        }
	
	        return 1;
	    }
	}
