# 抖音红人

## 题目描述

抖音工程师想要找到抖音里的红人！假设用户数为N，有M个关注关系对（A，B）。（A，B）表示用户A关注了用户B。关注关系具有传递性，例如：用户A关注了用户B，用户B关注了用户C，那么认为用户A间接关注了C。如果一个用户被所有N个用户直接或间接关注，那么我们认为这个用户就是抖音红人。求抖音红人的总数。

## 输入描述
第一行一个整数，代表N

第2行一个整数，代表M

第三行空格分隔的M*2个整数，代表关注关系对
## 输出描述
一行一个整数，表示答案

## 示例1
### 输入
	3
	3
	1 2 2 1 2 3
### 输出
	1
### 备注
	1<=M<=10^4
	
	1<=M<=5*10^4
	
	A<=A,B<=N

----

	import java.util.*;
	
	/*抖音红人*/
	class edge {
	    int from, to, next;
	
	    public edge(int a, int b, int c) {
	        from = a;
	        to = b;
	        next = c;
	    }
	}
	
	class Solution {
	
	    int n, m;
	    int header[];
	    edge edges[];
	    int cnt = 0;
	    boolean vis[];
	
	    void solver() {
	        Scanner scan = new Scanner(System.in);
	        n = scan.nextInt();
	        m = scan.nextInt();
	        header = new int[n + 1];
	        Arrays.fill(header, -1);
	        edges = new edge[m];
	        vis = new boolean[n + 1];
	        for (int i = 0; i < m; i++) {
	            int f = scan.nextInt();
	            int t = scan.nextInt();
	            edges[i] = new edge(t, f, header[t]);
	
	            header[t] = cnt++;
	
	        }
	
	        int total = 0;
	        for (int i = 1; i <= n; i++) {
	            Arrays.fill(vis, false);
	            vis[i] = true;
	            int tmp = dfs(i);
	            if (tmp == n) total++;
	        }
	
	        System.out.println(total);
	    }
	
	    int dfs(int cur) {
	        int s = 1;
	        for (int i = header[cur]; i != -1; i = edges[i].next) {
	            edge t = edges[i];
	            if (!vis[t.to]) {
	                vis[t.to] = true;
	                s += dfs(t.to);
	            }
	        }
	
	        return s;
	    }
	}
	
	public class Main5 {
	
	    public static void main(String[] args) {
	        Solution s = new Solution();
	        s.solver();
	    }
	
	}
