# 金山办公软件Android开发工程师笔试题（B卷）

## 一、问答题
### 1. ConcurrentHashMap 是怎么做并发控制的，相比 HashTable 有什么优势吗？

下面是对并发容器的简单介绍：

ConcurrentHashMap代替同步的Map（Collections.synchronized（new HashMap()）），众所周知，HashMap是根据散列值分段存储的，同步Map在同步的时候锁住了所有的段，而ConcurrentHashMap加锁的时候根据散列值锁住了散列值锁对应的那段，因此提高了并发性能。ConcurrentHashMap也增加了对常用复合操作的支持，比如"若没有则添加"：putIfAbsent()，替换：replace()。这2个操作都是原子操作。

CopyOnWriteArrayList和CopyOnWriteArraySet分别代替List和Set，主要是在遍历操作为主的情况下来代替同步的List和同步的Set，这也就是上面所述的思路：迭代过程要保证不出错，除了加锁，另外一种方法就是"克隆"容器对象。

ConcurrentLinkedQuerue是一个先进先出的队列。它是非阻塞队列。

ConcurrentSkipListMap可以在高效并发中替代SoredMap（例如用Collections.synchronzedMap包装的TreeMap）。

ConcurrentSkipListSet可以在高效并发中替代SoredSet（例如用Collections.synchronzedSet包装的TreeMap）。

### 2. 广播的两种注册方式有什么区别？

第一种是在配置文件里面进行静态注册，第二种是在代码中进行动态注册

两种注册类型的区别：

静态注册是当程序关闭后，如果有广播发过来，还能启动程序

动态注册的生命周期跟程序的生命周期是一样的，程序关闭后动态注册的广播是不能在接收到广播的

动态注册的优点：在Android的广播机制中，动态注册的优先级高于静态注册的优先级，因此在必要情况下，我们需要动态注册广播接收器。

静态注册的优点：动态注册广播接收器还有一个优点就是当用来注册广播的Activity关闭后，广播也就失效了，同时反映了静态注册广播的一个优势，就是无需担心广播接收器是否关闭，只要设备处于开启状态，广播接收器就能接收。

在AndroidManifest中进行注册后，不管改应用程序是否处于活动状态，都会进行监听，比如某个程序时监听 内存 的使用情况的，当在手机上安装好后，不管改应用程序是处于什么状态，都会执行改监听方法中的内容。

在代码中进行注册后，当应用程序关闭后，就不再进行监听。我们读知道，应用程序是否省电，决定了该应用程序的受欢迎程度，所以，对于那些没必要在程序关闭后仍然进行监听的Receiver，在代码中进行注册，无疑是一个明智的选择。

### 3. 安卓上，当系统资源不足时，会回收后台进程。请介绍一下Android的进程回收的策略（进程优先级）。如何应对系统回收时的数据保存与恢复。

前台进程
可见进程
服务进程
后台进程
空进程

### 4. 安卓上有哪些方式可以实现进程间通信？简述分别如何使用的。

1、使用Bundle

四大组件中三大组件Activity、Service、Receiver都支持在Intent中传递Bundle数据。

由于Bundle实现了Parcelable接口，所以它可以很方便的在不同的进程间传输数据。当然我们传输的数据必须能够被序列化，比如基本类型、实现了Parcelable接口的对象、实现了Serializable接口的对象以及一些Android支持的特殊对象。

2、使用文件共享

两个进程通过读写同一个文件来交换数据，比如A进程把数据写入文件，B进程通过读取这个文件来获取数据。

Android系统基于Linux，使得并发读写文件可以没有限制的进行，甚至两个线程同时对文件读写操作都是允许的，尽管可能出问题，因此文件共享方式适合在对数据同步要求不高的进程间进行通信。

SharedPreferences也属于文件的一种，但是由于系统对它的读写有一定的缓存策略，即在内存中会有一份SharedPreferences文件的缓存；因此在多进程模式下，系统对它的读写就变得不可靠，会有很大几率丢失数据，不建议在进程间通信中使用SharedPreferences。

3、使用Messenger

Messenger可以理解为信使，通过它可以再不同进程中传递Message对象，在Message中放入我们需要传递的数据，就可以实现数据的进程间传递了。

Messenger是一种轻量级的IPC方案，它的底层实现是AIDL。由于它一次处理一个请求，因此在服务端不需要考虑线程同步的问题，因为服务端不存在并发执行的情形。

4、使用AIDL

AIDL是 Android Interface definition language的缩写，它是一种android内部进程通信接口的描述语言。AIDL可以处理发送到服务器端大量的并发请求（不同与Messenger的串行处理方式），也可以实现跨进程的方法调用。

在Android中使用方法：创建一个Service和一个AIDL接口，接着创建一个类继承自AIDL接口中的Stub类并实现Stub中的抽象方法，在Service的onBind方法中返回这个类的对象，然后客户端绑定服务端Service，建立连接后就可以访问远程服务器了。

5、使用ContentProvider

ContentProvider是Android中提供的专门用于不同应用间进行数据共享的方式，天生适合进程间通信。

ContentProvider的底层实现也是Binder，但是它的使用过程比AIDL简单的多，因为系统做了封装，使得无需关心细节即可轻松实现IPC。ContentProvider主要以表格的形式组织数据，和数据库很类似，但ContentProvider对底层的数据存储方式没有任何要求，既可以使用Sqlite数据库，也可以使用文件方式，甚至可以使用内存中的一个对象来存储。

6、使用Socket

Socket套接字，是网络通信中的概念，分为流式套接字和用户数据奥套接字两种，对应于网络的传输控制层中的TCP和UDP协议。

两个进程可以通过Socket来实现信息的传输，Socket本身可以支持传输任意字节流。

### 5. 以下代码的输出是什么？

	public class Main {
	
	    static class KOutput {
	        public KOutput(String msg) {
	            System.out.println(msg);
	        }
	    }
	
	    static class KDummy {
	        private KOutput m1;
	        private KOutput m2 = new KOutput("Hello");
	        private static final KOutput s3 = new KOutput("Java");
	
	        public KDummy() {
	            m1 = new KOutput("World");
	        }
	    }
	
	    public static void main(String[] args) {
	        KDummy kDummy = new KDummy();
	    }
	
	}

OUTPUT:

	Java
	Hello
	World


## 二、编程题

### 1. 现有一链表 G（A->B->C->D->E），需要你编写转换的代码，将链表 G 转换成 （A->B->C->D->E->D->C->B->A），链表节点的数据结构如下：

	public class Node{
		public Node next;
	}

### 2. 设有一正整数 A，将其划分成整形数组 B，B 的数组元素和等于 A，使得数组元素之间的乘积最大，即求 Z=a1\*a2\*...*am 最大（M>=1）。例如：A=1,B={1},Z=1；  A=2,B={2},Z=2； A=3,B={3},Z=3；A=4,B={4}或B={2,2},Z=4； A=5,B={2,3},Z=6；