# 小球排列组合问题

## 题目描述
有 n 个红球，m 个蓝球，k 个绿球，同种颜色的球不作区分，把它们排成一行，要求相邻的两个球颜色不能相同，请问有多少种排列方式？

## 输入描述
为三个数字如   
3 4 5

数据范围   
3 <= n <= 20   
3 <= m <= 20     
3 <= k <= 20    
## 输出描述
588

## 示例1
### 输入
	15 15 15
	
### 输出
	2786716100592

----

	#include<bits/stdc++.h>
	
	using namespace std;
	typedef long long ll;
	
	ll dp[21][21][21];
	
	int main() {
	    std::ios::sync_with_stdio(false);
	    cin.tie(0);
	
	    ll m, n, k;
	    cin >> m >> n >> k;
	    vector<ll> vec;
	    vec.push_back(m);
	    vec.push_back(n);
	    vec.push_back(k);
	    sort(vec.begin(),vec.end());
	    m=vec.at(0);
	    n=vec.at(1);
	    k=vec.at(2);
	
	    if(k-m-n>1) {
	        cout << 0 << endl;
	        return 0;
	    }
	
	    for(int i=1; i<=m; i++) {
	        for(int j=1; j<=n; j++) {
	            for(int a=1; a<=k; a++) {
	                dp[i][j][a]=0;
	            }
	        }
	    }
	
	    for(int i=1; i<=m; i++) {
	        for(int j=i; j<=n; j++) {
	            for(int a=j; a<=k; a++) {
	
	                if(i==1&&j==1&&a==1) {
	                    dp[i][j][a]=6;
	                    continue;
	                }
	
	                if(i==j&&j==a) {
	                    dp[i][j][a]=dp[i-1][j][a]*(a+j+2-i);
	                    if(j>1) {
	                        dp[i][j][a]+=dp[i-1][j-1][a]*(j-1)*2;
	                    }
	                    dp[i][j][a]=dp[i][j][a]/i;
	                    continue;
	                }
	
	                if(j==a) {
	                    dp[i][j][a]=dp[i][j-1][a]*(a+i+2-j);
	                    if(i>1) {
	                        dp[i][j][a]+=dp[i-1][j-1][a]*(i-1);
	                    }
	                    if(a>1) {
	                        dp[i][j][a]+=dp[i][j-1][a-1]*(a-1);
	                    }
	                    dp[i][j][a]=dp[i][j][a]/j;
	                    continue;
	                }
	
	                if(a-j-i>1) {
	                    break;
	                }
	
	                dp[i][j][a]=dp[i][j][a-1]*(i+j+2-a);
	
	                if(i>1) {
	                    dp[i][j][a]+=dp[i-1][j][a-1]*(i-1);
	                }
	
	                if(j>1&&j>i) {
	                    dp[i][j][a]+=dp[i][j-1][a-1]*(j-1);
	                } else if(j>1&&j==i) {
	                    dp[i][j][a]+=dp[i-1][j][a-1]*(i-1);
	                }
	                dp[i][j][a]=dp[i][j][a]/a;
	            }
	        }
	    }
	    cout << dp[m][n][k] << endl;
	
	    return 0;
	}
