单选20 + 多选10 + 编程2（40 + 30 + 30）
## TCP 双方同时握手

## BSS 段
BSS（Block Started by Symbol）通常是指用来存放程序中未初始化的全局变量和静态变量的一块内存区域。特点是:可读写的，在程序执行之前BSS段会自动清0。所以，未初始的全局变量在程序执行之前已经成0了。

## 以下哪个不是系统调用 

	A. mmap 
	B. open 
	C. write 
	D. printf

## TCP 的 window字段（窗口机制）

## big end 大端（高尾端）

## 事务的四个特性

	A. 一致性
	B. 原子性
	C. 持久性
	D. 隔离性

## C++ 封装

	A. 类
	B. RAII
	C. 重载
	D. namespace

## （编程题）分隔回文串（空格分隔，回文串取长度最大）

	import java.util.Scanner;
	
	public class Main {
	
	    // "马拉车算法" 时间复杂度 O(N)
	    private static String Manacher(String rawString) {
	        // 插入 '#' 字符。以 "$#" 开始，以 "@" 结束
	        String tmpString = "$#";
	        for (int i = 0; i < rawString.length(); ++i) {
	            tmpString += rawString.charAt(i);
	            tmpString += "#";
	        }
	        tmpString += "@";
	
	        // process
	        int[] process = new int[tmpString.length()];
	        int mx = 0;
	        int id = 0;
	        int resLen = 0;
	        int resCenter = 0;
	        for (int i = 1; i < tmpString.length() - 1; ++i) {
	            process[i] = mx > i ? Math.min(process[2 * id - i], mx - i) : 1;
	            while (((i - process[i]) >= 0) && ((i + process[i]) < tmpString.length() - 1) && (tmpString.charAt(i + process[i]) == tmpString.charAt(i - process[i])))
	                ++process[i];
	            if (mx < i + process[i]) {
	                mx = i + process[i];
	                id = i;
	            }
	            if (resLen < process[i]) {
	                resLen = process[i];
	                resCenter = i;
	            }
	        }
	        return rawString.substring((resCenter - resLen) / 2, (resCenter - resLen) / 2 + resLen - 1);
	
	    }
	
	    public static void main(String[] args) {
	        Scanner scanner = new Scanner(System.in);
	        String str = scanner.nextLine();
	
	        System.out.print(Manacher(str));
	    }
	}


## （编程题）1 ~ n 整数中 1 出现的次数（剑指Offer 原题）

### AC代码：

	import java.util.Scanner;
	
	public class Main {
	
	    private static int countOnes(int n) {
	        int cnt = 0;
	        int tmp;
	        for (int m = 1; m <= n; m *= 10) {
	            if (n / m % 10 == 1) {
	                tmp = n % m + 1;
	            } else {
	                tmp = 0;
	            }
	            cnt = cnt + (n / m + 8) / 10 * m + tmp;
	        }
	        return cnt;
	    }
	
	    public static void main(String[] args) {
	        Scanner scanner = new Scanner(System.in);
	        int i = scanner.nextInt();
	        System.out.print(countOnes(i));
	    }
	}
